Imports System.io
Imports System.Globalization
Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form


#Region "Global Variables"

    Private ProgramDir As String = "C:\Program Files\Rohde&Schwarz\1GA50"
    Private WorkingDir As String = "D:\UPV\1GA50"
    Private Const NaN As Double = 3.402823466385E+38
    Private DecoderCalValue As Double = NaN
    Private EncoderCalValue As Double = NaN
    Private MobileInCalValue As Double = NaN
    Private MobileOutCalValue As Double = NaN
    Private Calib As New CMUCalFunctions
    Private MobileInCalFilter As String = String.Empty
    Private MobileOutCalFilter As String = String.Empty
    Private Const Version As String = "1.6.2"

#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()
        Thread.CurrentThread.CurrentCulture = New CultureInfo("")

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents DecoderCalButton1 As System.Windows.Forms.Button
    Friend WithEvents UplinkIOCalButton As System.Windows.Forms.Button
    Friend WithEvents DownlinkIOCalButton As System.Windows.Forms.Button
    Friend WithEvents CloseButton As System.Windows.Forms.Button
    Friend WithEvents NetworkLoopIOCalButton As System.Windows.Forms.Button
    Friend WithEvents MobileLoopIOCalButton As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents DecoderCalBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents DecoderCalBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents EncoderCalBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents DecoderCalBrowseButton3 As System.Windows.Forms.Button
    Friend WithEvents EncoderCalBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents UplinkSetupLoadButton As System.Windows.Forms.Button
    Friend WithEvents DownlinkSetupLoadButton As System.Windows.Forms.Button
    Friend WithEvents NetworkLoopSetupLoadButton As System.Windows.Forms.Button
    Friend WithEvents TabControl1 As System.Windows.Forms.TabControl
    Friend WithEvents TabPage1 As System.Windows.Forms.TabPage
    Friend WithEvents TabPage2 As System.Windows.Forms.TabPage
    Friend WithEvents TabPage3 As System.Windows.Forms.TabPage
    Friend WithEvents TabPage4 As System.Windows.Forms.TabPage
    Friend WithEvents UplinkSetupBrowseButton As System.Windows.Forms.Button
    Friend WithEvents DownlinkSetupBrowseButton As System.Windows.Forms.Button
    Friend WithEvents MinimizeCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents NetworkLoopBrowseButton As System.Windows.Forms.Button
    Friend WithEvents MobileLoopBrowseButton As System.Windows.Forms.Button
    Friend WithEvents ShowUplinkSchematicButton As System.Windows.Forms.Button
    Friend WithEvents ShowUplinkInstructionsButton As System.Windows.Forms.Button
    Friend WithEvents ShowDownlinkInstructionsButton As System.Windows.Forms.Button
    Friend WithEvents ShowDownlinkSchematicButton As System.Windows.Forms.Button
    Friend WithEvents ShowNetworkLoopInstructionsButton As System.Windows.Forms.Button
    Friend WithEvents ShowNetworkLoopSchematicButton As System.Windows.Forms.Button
    Friend WithEvents ShowMobileLoopInstructionsButton As System.Windows.Forms.Button
    Friend WithEvents ShowMobileLoopSchematicButton As System.Windows.Forms.Button
    Friend WithEvents DecoderCalFileTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents DecoderCalFileTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents DecoderCalValueTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents DecoderCalValueTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents UplinkSetupTextBox As System.Windows.Forms.TextBox
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents SaveFileDialog1 As System.Windows.Forms.SaveFileDialog
    Friend WithEvents EncoderCalFileTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents MobileOutCalFileTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents MobileOutCalFileTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents DecoderCalFileTextBox3 As System.Windows.Forms.TextBox
    Friend WithEvents EncoderCalFileTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents EncoderCalValueTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents MobileOutCalValueTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents MobileOutCalValueTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents DownlinkSetupTextBox As System.Windows.Forms.TextBox
    Friend WithEvents NetworkLoopSetupTextBox As System.Windows.Forms.TextBox
    Friend WithEvents MobileLoopSetupTextBox As System.Windows.Forms.TextBox
    Friend WithEvents MobileLoopSetupLoadButton As System.Windows.Forms.Button
    Friend WithEvents MobileInCalFileTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents MobileInCalFileTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents MobileInCalValueTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents MobileInCalValueTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents MobileInCalBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents MobileInCalBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents MobileOutCalBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents MobileOutCalBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents dBFSUpDown2 As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents dBFSUpDown1 As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents dBFSUpDown3 As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents dBFSUpDown4 As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents WavFileBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents WavFileTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents WavFileBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents WavFileTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents WavFileBrowseButton3 As System.Windows.Forms.Button
    Friend WithEvents WavFileTextBox3 As System.Windows.Forms.TextBox
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents WavFileBrowseButton4 As System.Windows.Forms.Button
    Friend WithEvents WavFileTextBox4 As System.Windows.Forms.TextBox
    Friend WithEvents WavFileClearButton1 As System.Windows.Forms.Button
    Friend WithEvents WavFileClearButton2 As System.Windows.Forms.Button
    Friend WithEvents WavFileClearButton3 As System.Windows.Forms.Button
    Friend WithEvents WavFileClearButton4 As System.Windows.Forms.Button
    Friend WithEvents EncoderCalButton1 As System.Windows.Forms.Button
    Friend WithEvents DecoderCalButton32 As System.Windows.Forms.Button
    Friend WithEvents DecoderCalButton3 As System.Windows.Forms.Button
    Friend WithEvents EncoderCalButton2 As System.Windows.Forms.Button
    Friend WithEvents EncoderCalValueTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents DecoderCalValueTextBox3 As System.Windows.Forms.TextBox
    Friend WithEvents StartCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents ClearButton As System.Windows.Forms.Button
    Friend WithEvents MobileInCalButton As System.Windows.Forms.Button
    Friend WithEvents MISpeechCalButton As System.Windows.Forms.Button
    Friend WithEvents GenFiltCheckBox As System.Windows.Forms.CheckBox
    Friend WithEvents GenFiltTextBox As System.Windows.Forms.TextBox
    Friend WithEvents GenFiltBrowseButton As System.Windows.Forms.Button
    Friend WithEvents GenFiltBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents GenFiltTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents GenFiltCheckBox1 As System.Windows.Forms.CheckBox
    Friend WithEvents AnFiltBrowseButton1 As System.Windows.Forms.Button
    Friend WithEvents AnFiltTextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents AnFiltCheckBox1 As System.Windows.Forms.CheckBox
    Friend WithEvents AnFiltBrowseButton2 As System.Windows.Forms.Button
    Friend WithEvents AnFiltTextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents AnFiltCheckBox2 As System.Windows.Forms.CheckBox
    Friend WithEvents UplinkIOSpeechCalButton As System.Windows.Forms.Button
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents RadioButton16 As System.Windows.Forms.RadioButton
    Friend WithEvents RadioButton26 As System.Windows.Forms.RadioButton
    Friend WithEvents MobileOutCalButton As System.Windows.Forms.Button
    Friend WithEvents FSCheckBox1 As System.Windows.Forms.CheckBox
    Friend WithEvents FSCheckBox2 As System.Windows.Forms.CheckBox
    Friend WithEvents FSCheckBox3 As System.Windows.Forms.CheckBox
    Friend WithEvents FSCheckBox4 As System.Windows.Forms.CheckBox
    Friend WithEvents DownlinkIOSpeechCalButton As System.Windows.Forms.Button
    Friend WithEvents NetworkLoopSpeechCalButton As System.Windows.Forms.Button
    Friend WithEvents MobileLoopSpeechCalButton As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.DecoderCalButton1 = New System.Windows.Forms.Button
        Me.EncoderCalButton1 = New System.Windows.Forms.Button
        Me.UplinkIOCalButton = New System.Windows.Forms.Button
        Me.DecoderCalButton32 = New System.Windows.Forms.Button
        Me.DownlinkIOCalButton = New System.Windows.Forms.Button
        Me.CloseButton = New System.Windows.Forms.Button
        Me.NetworkLoopIOCalButton = New System.Windows.Forms.Button
        Me.MobileLoopIOCalButton = New System.Windows.Forms.Button
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.MobileInCalButton = New System.Windows.Forms.Button
        Me.DecoderCalBrowseButton1 = New System.Windows.Forms.Button
        Me.MobileInCalBrowseButton1 = New System.Windows.Forms.Button
        Me.DecoderCalBrowseButton2 = New System.Windows.Forms.Button
        Me.EncoderCalBrowseButton1 = New System.Windows.Forms.Button
        Me.MobileInCalBrowseButton2 = New System.Windows.Forms.Button
        Me.MobileOutCalBrowseButton2 = New System.Windows.Forms.Button
        Me.MobileOutCalBrowseButton1 = New System.Windows.Forms.Button
        Me.DecoderCalBrowseButton3 = New System.Windows.Forms.Button
        Me.EncoderCalBrowseButton2 = New System.Windows.Forms.Button
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.UplinkSetupLoadButton = New System.Windows.Forms.Button
        Me.DownlinkSetupLoadButton = New System.Windows.Forms.Button
        Me.NetworkLoopSetupLoadButton = New System.Windows.Forms.Button
        Me.MobileLoopSetupLoadButton = New System.Windows.Forms.Button
        Me.UplinkSetupBrowseButton = New System.Windows.Forms.Button
        Me.DownlinkSetupBrowseButton = New System.Windows.Forms.Button
        Me.NetworkLoopBrowseButton = New System.Windows.Forms.Button
        Me.MobileLoopBrowseButton = New System.Windows.Forms.Button
        Me.ShowUplinkSchematicButton = New System.Windows.Forms.Button
        Me.ShowUplinkInstructionsButton = New System.Windows.Forms.Button
        Me.ShowDownlinkInstructionsButton = New System.Windows.Forms.Button
        Me.ShowDownlinkSchematicButton = New System.Windows.Forms.Button
        Me.ShowNetworkLoopInstructionsButton = New System.Windows.Forms.Button
        Me.ShowNetworkLoopSchematicButton = New System.Windows.Forms.Button
        Me.ShowMobileLoopInstructionsButton = New System.Windows.Forms.Button
        Me.ShowMobileLoopSchematicButton = New System.Windows.Forms.Button
        Me.WavFileClearButton1 = New System.Windows.Forms.Button
        Me.Label14 = New System.Windows.Forms.Label
        Me.WavFileBrowseButton1 = New System.Windows.Forms.Button
        Me.WavFileTextBox1 = New System.Windows.Forms.TextBox
        Me.Label8 = New System.Windows.Forms.Label
        Me.dBFSUpDown1 = New System.Windows.Forms.NumericUpDown
        Me.Label9 = New System.Windows.Forms.Label
        Me.DecoderCalValueTextBox1 = New System.Windows.Forms.TextBox
        Me.MobileInCalValueTextBox1 = New System.Windows.Forms.TextBox
        Me.WavFileClearButton2 = New System.Windows.Forms.Button
        Me.Label15 = New System.Windows.Forms.Label
        Me.WavFileBrowseButton2 = New System.Windows.Forms.Button
        Me.WavFileTextBox2 = New System.Windows.Forms.TextBox
        Me.Label7 = New System.Windows.Forms.Label
        Me.dBFSUpDown2 = New System.Windows.Forms.NumericUpDown
        Me.Label6 = New System.Windows.Forms.Label
        Me.DecoderCalValueTextBox2 = New System.Windows.Forms.TextBox
        Me.MobileOutCalFileTextBox1 = New System.Windows.Forms.TextBox
        Me.MobileOutCalValueTextBox1 = New System.Windows.Forms.TextBox
        Me.EncoderCalValueTextBox1 = New System.Windows.Forms.TextBox
        Me.EncoderCalFileTextBox1 = New System.Windows.Forms.TextBox
        Me.DecoderCalFileTextBox2 = New System.Windows.Forms.TextBox
        Me.WavFileClearButton3 = New System.Windows.Forms.Button
        Me.Label16 = New System.Windows.Forms.Label
        Me.WavFileBrowseButton3 = New System.Windows.Forms.Button
        Me.WavFileTextBox3 = New System.Windows.Forms.TextBox
        Me.Label10 = New System.Windows.Forms.Label
        Me.dBFSUpDown3 = New System.Windows.Forms.NumericUpDown
        Me.Label11 = New System.Windows.Forms.Label
        Me.MobileInCalValueTextBox2 = New System.Windows.Forms.TextBox
        Me.MobileOutCalValueTextBox2 = New System.Windows.Forms.TextBox
        Me.EncoderCalButton2 = New System.Windows.Forms.Button
        Me.DecoderCalButton3 = New System.Windows.Forms.Button
        Me.WavFileClearButton4 = New System.Windows.Forms.Button
        Me.Label17 = New System.Windows.Forms.Label
        Me.WavFileBrowseButton4 = New System.Windows.Forms.Button
        Me.WavFileTextBox4 = New System.Windows.Forms.TextBox
        Me.Label12 = New System.Windows.Forms.Label
        Me.dBFSUpDown4 = New System.Windows.Forms.NumericUpDown
        Me.Label13 = New System.Windows.Forms.Label
        Me.EncoderCalValueTextBox2 = New System.Windows.Forms.TextBox
        Me.DecoderCalValueTextBox3 = New System.Windows.Forms.TextBox
        Me.MISpeechCalButton = New System.Windows.Forms.Button
        Me.GenFiltBrowseButton = New System.Windows.Forms.Button
        Me.GenFiltBrowseButton1 = New System.Windows.Forms.Button
        Me.AnFiltBrowseButton1 = New System.Windows.Forms.Button
        Me.AnFiltBrowseButton2 = New System.Windows.Forms.Button
        Me.UplinkIOSpeechCalButton = New System.Windows.Forms.Button
        Me.MobileOutCalButton = New System.Windows.Forms.Button
        Me.DownlinkIOSpeechCalButton = New System.Windows.Forms.Button
        Me.NetworkLoopSpeechCalButton = New System.Windows.Forms.Button
        Me.MobileLoopSpeechCalButton = New System.Windows.Forms.Button
        Me.TabControl1 = New System.Windows.Forms.TabControl
        Me.TabPage1 = New System.Windows.Forms.TabPage
        Me.FSCheckBox1 = New System.Windows.Forms.CheckBox
        Me.GroupBox1 = New System.Windows.Forms.GroupBox
        Me.RadioButton26 = New System.Windows.Forms.RadioButton
        Me.RadioButton16 = New System.Windows.Forms.RadioButton
        Me.GenFiltTextBox = New System.Windows.Forms.TextBox
        Me.GenFiltCheckBox = New System.Windows.Forms.CheckBox
        Me.MobileInCalFileTextBox1 = New System.Windows.Forms.TextBox
        Me.DecoderCalFileTextBox1 = New System.Windows.Forms.TextBox
        Me.UplinkSetupTextBox = New System.Windows.Forms.TextBox
        Me.TabPage2 = New System.Windows.Forms.TabPage
        Me.FSCheckBox2 = New System.Windows.Forms.CheckBox
        Me.AnFiltTextBox2 = New System.Windows.Forms.TextBox
        Me.AnFiltCheckBox2 = New System.Windows.Forms.CheckBox
        Me.DownlinkSetupTextBox = New System.Windows.Forms.TextBox
        Me.TabPage3 = New System.Windows.Forms.TabPage
        Me.FSCheckBox3 = New System.Windows.Forms.CheckBox
        Me.AnFiltTextBox1 = New System.Windows.Forms.TextBox
        Me.AnFiltCheckBox1 = New System.Windows.Forms.CheckBox
        Me.GenFiltTextBox1 = New System.Windows.Forms.TextBox
        Me.GenFiltCheckBox1 = New System.Windows.Forms.CheckBox
        Me.MobileInCalFileTextBox2 = New System.Windows.Forms.TextBox
        Me.NetworkLoopSetupTextBox = New System.Windows.Forms.TextBox
        Me.MobileOutCalFileTextBox2 = New System.Windows.Forms.TextBox
        Me.TabPage4 = New System.Windows.Forms.TabPage
        Me.FSCheckBox4 = New System.Windows.Forms.CheckBox
        Me.MobileLoopSetupTextBox = New System.Windows.Forms.TextBox
        Me.EncoderCalFileTextBox2 = New System.Windows.Forms.TextBox
        Me.DecoderCalFileTextBox3 = New System.Windows.Forms.TextBox
        Me.MinimizeCheckBox = New System.Windows.Forms.CheckBox
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog
        Me.SaveFileDialog1 = New System.Windows.Forms.SaveFileDialog
        Me.StartCheckBox = New System.Windows.Forms.CheckBox
        Me.ClearButton = New System.Windows.Forms.Button
        CType(Me.dBFSUpDown1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.dBFSUpDown2, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.dBFSUpDown3, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.dBFSUpDown4, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.TabControl1.SuspendLayout()
        Me.TabPage1.SuspendLayout()
        Me.GroupBox1.SuspendLayout()
        Me.TabPage2.SuspendLayout()
        Me.TabPage3.SuspendLayout()
        Me.TabPage4.SuspendLayout()
        Me.SuspendLayout()
        '
        'DecoderCalButton1
        '
        Me.DecoderCalButton1.Location = New System.Drawing.Point(16, 56)
        Me.DecoderCalButton1.Name = "DecoderCalButton1"
        Me.DecoderCalButton1.Size = New System.Drawing.Size(128, 23)
        Me.DecoderCalButton1.TabIndex = 2
        Me.DecoderCalButton1.Text = "Decoder Cal."
        Me.ToolTip1.SetToolTip(Me.DecoderCalButton1, "Measures FS output voltage of system simulator")
        '
        'EncoderCalButton1
        '
        Me.EncoderCalButton1.Location = New System.Drawing.Point(16, 96)
        Me.EncoderCalButton1.Name = "EncoderCalButton1"
        Me.EncoderCalButton1.Size = New System.Drawing.Size(128, 23)
        Me.EncoderCalButton1.TabIndex = 4
        Me.EncoderCalButton1.Text = "Encoder Cal."
        Me.ToolTip1.SetToolTip(Me.EncoderCalButton1, "Determines FS input voltage of system simulator and mobile output voltage")
        '
        'UplinkIOCalButton
        '
        Me.UplinkIOCalButton.Location = New System.Drawing.Point(16, 176)
        Me.UplinkIOCalButton.Name = "UplinkIOCalButton"
        Me.UplinkIOCalButton.Size = New System.Drawing.Size(128, 23)
        Me.UplinkIOCalButton.TabIndex = 6
        Me.UplinkIOCalButton.Text = "In/Out Cal."
        Me.ToolTip1.SetToolTip(Me.UplinkIOCalButton, "Alternative method using the input/output-curve")
        '
        'DecoderCalButton32
        '
        Me.DecoderCalButton32.Location = New System.Drawing.Point(16, 56)
        Me.DecoderCalButton32.Name = "DecoderCalButton32"
        Me.DecoderCalButton32.Size = New System.Drawing.Size(128, 23)
        Me.DecoderCalButton32.TabIndex = 2
        Me.DecoderCalButton32.Text = "Decoder Cal."
        Me.ToolTip1.SetToolTip(Me.DecoderCalButton32, "Measures FS output voltage of system simulator")
        '
        'DownlinkIOCalButton
        '
        Me.DownlinkIOCalButton.Location = New System.Drawing.Point(16, 176)
        Me.DownlinkIOCalButton.Name = "DownlinkIOCalButton"
        Me.DownlinkIOCalButton.Size = New System.Drawing.Size(128, 23)
        Me.DownlinkIOCalButton.TabIndex = 7
        Me.DownlinkIOCalButton.Text = "In/Out Cal."
        Me.ToolTip1.SetToolTip(Me.DownlinkIOCalButton, "Alternative method using the input/output-curve")
        '
        'CloseButton
        '
        Me.CloseButton.Location = New System.Drawing.Point(568, 464)
        Me.CloseButton.Name = "CloseButton"
        Me.CloseButton.Size = New System.Drawing.Size(104, 23)
        Me.CloseButton.TabIndex = 2
        Me.CloseButton.Text = "Close"
        '
        'NetworkLoopIOCalButton
        '
        Me.NetworkLoopIOCalButton.Location = New System.Drawing.Point(16, 136)
        Me.NetworkLoopIOCalButton.Name = "NetworkLoopIOCalButton"
        Me.NetworkLoopIOCalButton.Size = New System.Drawing.Size(128, 23)
        Me.NetworkLoopIOCalButton.TabIndex = 4
        Me.NetworkLoopIOCalButton.Text = "In/Out Cal."
        Me.ToolTip1.SetToolTip(Me.NetworkLoopIOCalButton, "Alternative method using the input/output-curve")
        '
        'MobileLoopIOCalButton
        '
        Me.MobileLoopIOCalButton.Location = New System.Drawing.Point(16, 136)
        Me.MobileLoopIOCalButton.Name = "MobileLoopIOCalButton"
        Me.MobileLoopIOCalButton.Size = New System.Drawing.Size(128, 23)
        Me.MobileLoopIOCalButton.TabIndex = 4
        Me.MobileLoopIOCalButton.Text = "In/Out Cal."
        Me.ToolTip1.SetToolTip(Me.MobileLoopIOCalButton, "Alternative method using the input/output-curve")
        '
        'MobileInCalButton
        '
        Me.MobileInCalButton.Location = New System.Drawing.Point(16, 96)
        Me.MobileInCalButton.Name = "MobileInCalButton"
        Me.MobileInCalButton.Size = New System.Drawing.Size(128, 23)
        Me.MobileInCalButton.TabIndex = 4
        Me.MobileInCalButton.Text = "Mobile Input Cal."
        Me.ToolTip1.SetToolTip(Me.MobileInCalButton, "Measures FS decoder output voltage")
        '
        'DecoderCalBrowseButton1
        '
        Me.DecoderCalBrowseButton1.Location = New System.Drawing.Point(448, 56)
        Me.DecoderCalBrowseButton1.Name = "DecoderCalBrowseButton1"
        Me.DecoderCalBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.DecoderCalBrowseButton1.TabIndex = 3
        Me.DecoderCalBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.DecoderCalBrowseButton1, "Load decoder calibration from file")
        '
        'MobileInCalBrowseButton1
        '
        Me.MobileInCalBrowseButton1.Location = New System.Drawing.Point(448, 96)
        Me.MobileInCalBrowseButton1.Name = "MobileInCalBrowseButton1"
        Me.MobileInCalBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.MobileInCalBrowseButton1.TabIndex = 5
        Me.MobileInCalBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.MobileInCalBrowseButton1, "Load mobile input calibration from file")
        '
        'DecoderCalBrowseButton2
        '
        Me.DecoderCalBrowseButton2.Location = New System.Drawing.Point(448, 56)
        Me.DecoderCalBrowseButton2.Name = "DecoderCalBrowseButton2"
        Me.DecoderCalBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.DecoderCalBrowseButton2.TabIndex = 3
        Me.DecoderCalBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.DecoderCalBrowseButton2, "Load decoder calibration from file")
        '
        'EncoderCalBrowseButton1
        '
        Me.EncoderCalBrowseButton1.Location = New System.Drawing.Point(448, 96)
        Me.EncoderCalBrowseButton1.Name = "EncoderCalBrowseButton1"
        Me.EncoderCalBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.EncoderCalBrowseButton1.TabIndex = 5
        Me.EncoderCalBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.EncoderCalBrowseButton1, "Load encoder calibration from file")
        '
        'MobileInCalBrowseButton2
        '
        Me.MobileInCalBrowseButton2.Location = New System.Drawing.Point(448, 56)
        Me.MobileInCalBrowseButton2.Name = "MobileInCalBrowseButton2"
        Me.MobileInCalBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.MobileInCalBrowseButton2.TabIndex = 2
        Me.MobileInCalBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.MobileInCalBrowseButton2, "Load mobile input calibration from file")
        '
        'MobileOutCalBrowseButton2
        '
        Me.MobileOutCalBrowseButton2.Location = New System.Drawing.Point(448, 96)
        Me.MobileOutCalBrowseButton2.Name = "MobileOutCalBrowseButton2"
        Me.MobileOutCalBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.MobileOutCalBrowseButton2.TabIndex = 3
        Me.MobileOutCalBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.MobileOutCalBrowseButton2, "Load mobile output calibration from file")
        '
        'MobileOutCalBrowseButton1
        '
        Me.MobileOutCalBrowseButton1.Location = New System.Drawing.Point(448, 136)
        Me.MobileOutCalBrowseButton1.Name = "MobileOutCalBrowseButton1"
        Me.MobileOutCalBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.MobileOutCalBrowseButton1.TabIndex = 6
        Me.MobileOutCalBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.MobileOutCalBrowseButton1, "Load mobile output calibration from file")
        '
        'DecoderCalBrowseButton3
        '
        Me.DecoderCalBrowseButton3.Location = New System.Drawing.Point(448, 96)
        Me.DecoderCalBrowseButton3.Name = "DecoderCalBrowseButton3"
        Me.DecoderCalBrowseButton3.Size = New System.Drawing.Size(80, 23)
        Me.DecoderCalBrowseButton3.TabIndex = 3
        Me.DecoderCalBrowseButton3.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.DecoderCalBrowseButton3, "Load decoder calibration")
        '
        'EncoderCalBrowseButton2
        '
        Me.EncoderCalBrowseButton2.Location = New System.Drawing.Point(448, 56)
        Me.EncoderCalBrowseButton2.Name = "EncoderCalBrowseButton2"
        Me.EncoderCalBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.EncoderCalBrowseButton2.TabIndex = 2
        Me.EncoderCalBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.EncoderCalBrowseButton2, "Load encoder calibration")
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(136, 23)
        Me.Label2.TabIndex = 7
        Me.Label2.Text = "Mobile Input Cal."
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label2, "FS input voltage of mobile phone")
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(16, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(136, 23)
        Me.Label3.TabIndex = 10
        Me.Label3.Text = "Mobile Output Cal."
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label3, "FS output voltage of mobile phone")
        '
        'UplinkSetupLoadButton
        '
        Me.UplinkSetupLoadButton.Location = New System.Drawing.Point(16, 296)
        Me.UplinkSetupLoadButton.Name = "UplinkSetupLoadButton"
        Me.UplinkSetupLoadButton.Size = New System.Drawing.Size(128, 23)
        Me.UplinkSetupLoadButton.TabIndex = 7
        Me.UplinkSetupLoadButton.Text = "Load Setup"
        Me.ToolTip1.SetToolTip(Me.UplinkSetupLoadButton, "Loads setup for uplink and enters calibration values")
        '
        'DownlinkSetupLoadButton
        '
        Me.DownlinkSetupLoadButton.Location = New System.Drawing.Point(16, 296)
        Me.DownlinkSetupLoadButton.Name = "DownlinkSetupLoadButton"
        Me.DownlinkSetupLoadButton.Size = New System.Drawing.Size(128, 23)
        Me.DownlinkSetupLoadButton.TabIndex = 8
        Me.DownlinkSetupLoadButton.Text = "Load Setup"
        Me.ToolTip1.SetToolTip(Me.DownlinkSetupLoadButton, "Loads setup for downlink and enters calibration values")
        '
        'NetworkLoopSetupLoadButton
        '
        Me.NetworkLoopSetupLoadButton.Location = New System.Drawing.Point(16, 296)
        Me.NetworkLoopSetupLoadButton.Name = "NetworkLoopSetupLoadButton"
        Me.NetworkLoopSetupLoadButton.Size = New System.Drawing.Size(128, 23)
        Me.NetworkLoopSetupLoadButton.TabIndex = 5
        Me.NetworkLoopSetupLoadButton.Text = "Load Setup"
        Me.ToolTip1.SetToolTip(Me.NetworkLoopSetupLoadButton, "Loads setup for network loopback and enters calibration values")
        '
        'MobileLoopSetupLoadButton
        '
        Me.MobileLoopSetupLoadButton.Location = New System.Drawing.Point(16, 296)
        Me.MobileLoopSetupLoadButton.Name = "MobileLoopSetupLoadButton"
        Me.MobileLoopSetupLoadButton.Size = New System.Drawing.Size(128, 23)
        Me.MobileLoopSetupLoadButton.TabIndex = 5
        Me.MobileLoopSetupLoadButton.Text = "Load Setup"
        Me.ToolTip1.SetToolTip(Me.MobileLoopSetupLoadButton, "d setup for mobile loopback and enters calibration values")
        '
        'UplinkSetupBrowseButton
        '
        Me.UplinkSetupBrowseButton.Location = New System.Drawing.Point(448, 296)
        Me.UplinkSetupBrowseButton.Name = "UplinkSetupBrowseButton"
        Me.UplinkSetupBrowseButton.Size = New System.Drawing.Size(192, 23)
        Me.UplinkSetupBrowseButton.TabIndex = 8
        Me.UplinkSetupBrowseButton.Text = "Browse and Load Setup"
        Me.ToolTip1.SetToolTip(Me.UplinkSetupBrowseButton, "Measures FS decoder output voltage")
        '
        'DownlinkSetupBrowseButton
        '
        Me.DownlinkSetupBrowseButton.Location = New System.Drawing.Point(448, 296)
        Me.DownlinkSetupBrowseButton.Name = "DownlinkSetupBrowseButton"
        Me.DownlinkSetupBrowseButton.Size = New System.Drawing.Size(192, 23)
        Me.DownlinkSetupBrowseButton.TabIndex = 9
        Me.DownlinkSetupBrowseButton.Text = "Browse and Load Setup"
        Me.ToolTip1.SetToolTip(Me.DownlinkSetupBrowseButton, "Measures FS decoder output voltage")
        '
        'NetworkLoopBrowseButton
        '
        Me.NetworkLoopBrowseButton.Location = New System.Drawing.Point(448, 296)
        Me.NetworkLoopBrowseButton.Name = "NetworkLoopBrowseButton"
        Me.NetworkLoopBrowseButton.Size = New System.Drawing.Size(192, 23)
        Me.NetworkLoopBrowseButton.TabIndex = 6
        Me.NetworkLoopBrowseButton.Text = "Browse and Load Setup"
        Me.ToolTip1.SetToolTip(Me.NetworkLoopBrowseButton, "Measures FS decoder output voltage")
        '
        'MobileLoopBrowseButton
        '
        Me.MobileLoopBrowseButton.Location = New System.Drawing.Point(448, 296)
        Me.MobileLoopBrowseButton.Name = "MobileLoopBrowseButton"
        Me.MobileLoopBrowseButton.Size = New System.Drawing.Size(192, 23)
        Me.MobileLoopBrowseButton.TabIndex = 6
        Me.MobileLoopBrowseButton.Text = "Browse and Load Setup"
        Me.ToolTip1.SetToolTip(Me.MobileLoopBrowseButton, "Measures FS decoder output voltage")
        '
        'ShowUplinkSchematicButton
        '
        Me.ShowUplinkSchematicButton.Location = New System.Drawing.Point(16, 16)
        Me.ShowUplinkSchematicButton.Name = "ShowUplinkSchematicButton"
        Me.ShowUplinkSchematicButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowUplinkSchematicButton.TabIndex = 0
        Me.ShowUplinkSchematicButton.Text = "Show Schematic"
        Me.ToolTip1.SetToolTip(Me.ShowUplinkSchematicButton, "Schematic for uplink test")
        '
        'ShowUplinkInstructionsButton
        '
        Me.ShowUplinkInstructionsButton.Location = New System.Drawing.Point(152, 16)
        Me.ShowUplinkInstructionsButton.Name = "ShowUplinkInstructionsButton"
        Me.ShowUplinkInstructionsButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowUplinkInstructionsButton.TabIndex = 1
        Me.ShowUplinkInstructionsButton.Text = "Show Instructions"
        Me.ToolTip1.SetToolTip(Me.ShowUplinkInstructionsButton, "Instructions for uplink calibration and test")
        '
        'ShowDownlinkInstructionsButton
        '
        Me.ShowDownlinkInstructionsButton.Location = New System.Drawing.Point(152, 16)
        Me.ShowDownlinkInstructionsButton.Name = "ShowDownlinkInstructionsButton"
        Me.ShowDownlinkInstructionsButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowDownlinkInstructionsButton.TabIndex = 1
        Me.ShowDownlinkInstructionsButton.Text = "Show Instructions"
        Me.ToolTip1.SetToolTip(Me.ShowDownlinkInstructionsButton, "Instructions for downlink calibration and test")
        '
        'ShowDownlinkSchematicButton
        '
        Me.ShowDownlinkSchematicButton.Location = New System.Drawing.Point(16, 16)
        Me.ShowDownlinkSchematicButton.Name = "ShowDownlinkSchematicButton"
        Me.ShowDownlinkSchematicButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowDownlinkSchematicButton.TabIndex = 0
        Me.ShowDownlinkSchematicButton.Text = "Show Schematic"
        Me.ToolTip1.SetToolTip(Me.ShowDownlinkSchematicButton, "Schematic for downlink")
        '
        'ShowNetworkLoopInstructionsButton
        '
        Me.ShowNetworkLoopInstructionsButton.Location = New System.Drawing.Point(152, 16)
        Me.ShowNetworkLoopInstructionsButton.Name = "ShowNetworkLoopInstructionsButton"
        Me.ShowNetworkLoopInstructionsButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowNetworkLoopInstructionsButton.TabIndex = 1
        Me.ShowNetworkLoopInstructionsButton.Text = "Show Instructions"
        Me.ToolTip1.SetToolTip(Me.ShowNetworkLoopInstructionsButton, "Instructions for measurement with loopback on the network side")
        '
        'ShowNetworkLoopSchematicButton
        '
        Me.ShowNetworkLoopSchematicButton.Location = New System.Drawing.Point(16, 16)
        Me.ShowNetworkLoopSchematicButton.Name = "ShowNetworkLoopSchematicButton"
        Me.ShowNetworkLoopSchematicButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowNetworkLoopSchematicButton.TabIndex = 0
        Me.ShowNetworkLoopSchematicButton.Text = "Show Schematic"
        Me.ToolTip1.SetToolTip(Me.ShowNetworkLoopSchematicButton, "Measures FS output voltage of system simulator")
        '
        'ShowMobileLoopInstructionsButton
        '
        Me.ShowMobileLoopInstructionsButton.Location = New System.Drawing.Point(152, 16)
        Me.ShowMobileLoopInstructionsButton.Name = "ShowMobileLoopInstructionsButton"
        Me.ShowMobileLoopInstructionsButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowMobileLoopInstructionsButton.TabIndex = 1
        Me.ShowMobileLoopInstructionsButton.Text = "Show Instructions"
        Me.ToolTip1.SetToolTip(Me.ShowMobileLoopInstructionsButton, "Instructions for measurement with loopback on the mobile side")
        '
        'ShowMobileLoopSchematicButton
        '
        Me.ShowMobileLoopSchematicButton.Location = New System.Drawing.Point(16, 16)
        Me.ShowMobileLoopSchematicButton.Name = "ShowMobileLoopSchematicButton"
        Me.ShowMobileLoopSchematicButton.Size = New System.Drawing.Size(128, 23)
        Me.ShowMobileLoopSchematicButton.TabIndex = 0
        Me.ShowMobileLoopSchematicButton.Text = "Show Schematic"
        Me.ToolTip1.SetToolTip(Me.ShowMobileLoopSchematicButton, "Schematic for loopback on the mobile side")
        '
        'WavFileClearButton1
        '
        Me.WavFileClearButton1.Location = New System.Drawing.Point(536, 216)
        Me.WavFileClearButton1.Name = "WavFileClearButton1"
        Me.WavFileClearButton1.Size = New System.Drawing.Size(80, 23)
        Me.WavFileClearButton1.TabIndex = 27
        Me.WavFileClearButton1.Text = "Clear"
        Me.ToolTip1.SetToolTip(Me.WavFileClearButton1, "Load mobile input calibration from file")
        '
        'Label14
        '
        Me.Label14.Location = New System.Drawing.Point(16, 216)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(128, 23)
        Me.Label14.TabIndex = 26
        Me.Label14.Text = "Test Signal wav File"
        Me.Label14.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label14, "FS output voltage of mobile phone")
        '
        'WavFileBrowseButton1
        '
        Me.WavFileBrowseButton1.Location = New System.Drawing.Point(448, 216)
        Me.WavFileBrowseButton1.Name = "WavFileBrowseButton1"
        Me.WavFileBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.WavFileBrowseButton1.TabIndex = 24
        Me.WavFileBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.WavFileBrowseButton1, "Load mobile input calibration from file")
        '
        'WavFileTextBox1
        '
        Me.WavFileTextBox1.Location = New System.Drawing.Point(152, 216)
        Me.WavFileTextBox1.Name = "WavFileTextBox1"
        Me.WavFileTextBox1.ReadOnly = True
        Me.WavFileTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.WavFileTextBox1.TabIndex = 25
        Me.WavFileTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.WavFileTextBox1, "Path name of test signal file")
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(224, 256)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(376, 23)
        Me.Label8.TabIndex = 23
        Me.Label8.Text = "dBFs (peak) of mobile input"
        Me.Label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label8, "FS output voltage of mobile phone")
        '
        'dBFSUpDown1
        '
        Me.dBFSUpDown1.DecimalPlaces = 1
        Me.dBFSUpDown1.Location = New System.Drawing.Point(152, 256)
        Me.dBFSUpDown1.Minimum = New Decimal(New Integer() {100, 0, 0, -2147483648})
        Me.dBFSUpDown1.Name = "dBFSUpDown1"
        Me.dBFSUpDown1.Size = New System.Drawing.Size(64, 21)
        Me.dBFSUpDown1.TabIndex = 22
        Me.dBFSUpDown1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.dBFSUpDown1, "FS peak voltage of signal in terms of dBFS at the mobile input")
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(16, 256)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(136, 23)
        Me.Label9.TabIndex = 21
        Me.Label9.Text = "Set Fs of wav file to"
        Me.Label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label9, "FS output voltage of mobile phone")
        '
        'DecoderCalValueTextBox1
        '
        Me.DecoderCalValueTextBox1.Location = New System.Drawing.Point(536, 56)
        Me.DecoderCalValueTextBox1.Name = "DecoderCalValueTextBox1"
        Me.DecoderCalValueTextBox1.ReadOnly = True
        Me.DecoderCalValueTextBox1.Size = New System.Drawing.Size(104, 21)
        Me.DecoderCalValueTextBox1.TabIndex = 10
        Me.DecoderCalValueTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.DecoderCalValueTextBox1, "FS peak decoder output voltage")
        '
        'MobileInCalValueTextBox1
        '
        Me.MobileInCalValueTextBox1.Location = New System.Drawing.Point(536, 96)
        Me.MobileInCalValueTextBox1.Name = "MobileInCalValueTextBox1"
        Me.MobileInCalValueTextBox1.ReadOnly = True
        Me.MobileInCalValueTextBox1.Size = New System.Drawing.Size(104, 21)
        Me.MobileInCalValueTextBox1.TabIndex = 12
        Me.MobileInCalValueTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.MobileInCalValueTextBox1, "FS peak mobile input voltage")
        '
        'WavFileClearButton2
        '
        Me.WavFileClearButton2.Location = New System.Drawing.Point(536, 216)
        Me.WavFileClearButton2.Name = "WavFileClearButton2"
        Me.WavFileClearButton2.Size = New System.Drawing.Size(80, 23)
        Me.WavFileClearButton2.TabIndex = 30
        Me.WavFileClearButton2.Text = "Clear"
        Me.ToolTip1.SetToolTip(Me.WavFileClearButton2, "Load mobile input calibration from file")
        '
        'Label15
        '
        Me.Label15.Location = New System.Drawing.Point(16, 216)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(128, 23)
        Me.Label15.TabIndex = 29
        Me.Label15.Text = "Test Signal wav File"
        Me.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label15, "FS output voltage of mobile phone")
        '
        'WavFileBrowseButton2
        '
        Me.WavFileBrowseButton2.Location = New System.Drawing.Point(448, 216)
        Me.WavFileBrowseButton2.Name = "WavFileBrowseButton2"
        Me.WavFileBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.WavFileBrowseButton2.TabIndex = 27
        Me.WavFileBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.WavFileBrowseButton2, "Load mobile input calibration from file")
        '
        'WavFileTextBox2
        '
        Me.WavFileTextBox2.Location = New System.Drawing.Point(152, 216)
        Me.WavFileTextBox2.Name = "WavFileTextBox2"
        Me.WavFileTextBox2.ReadOnly = True
        Me.WavFileTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.WavFileTextBox2.TabIndex = 28
        Me.WavFileTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.WavFileTextBox2, "Path name of test signal file")
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(224, 256)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(200, 23)
        Me.Label7.TabIndex = 20
        Me.Label7.Text = "dBFs (peak) of encoder input"
        Me.Label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label7, "FS output voltage of mobile phone")
        '
        'dBFSUpDown2
        '
        Me.dBFSUpDown2.DecimalPlaces = 1
        Me.dBFSUpDown2.Location = New System.Drawing.Point(152, 256)
        Me.dBFSUpDown2.Minimum = New Decimal(New Integer() {100, 0, 0, -2147483648})
        Me.dBFSUpDown2.Name = "dBFSUpDown2"
        Me.dBFSUpDown2.Size = New System.Drawing.Size(64, 21)
        Me.dBFSUpDown2.TabIndex = 19
        Me.dBFSUpDown2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.dBFSUpDown2, "FS peak voltage of signal in terms of dBFS at the encoder input")
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(16, 256)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(128, 23)
        Me.Label6.TabIndex = 18
        Me.Label6.Text = "Set Fs of wav file to"
        Me.Label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label6, "FS output voltage of mobile phone")
        '
        'DecoderCalValueTextBox2
        '
        Me.DecoderCalValueTextBox2.Location = New System.Drawing.Point(536, 56)
        Me.DecoderCalValueTextBox2.Name = "DecoderCalValueTextBox2"
        Me.DecoderCalValueTextBox2.ReadOnly = True
        Me.DecoderCalValueTextBox2.Size = New System.Drawing.Size(104, 21)
        Me.DecoderCalValueTextBox2.TabIndex = 11
        Me.DecoderCalValueTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.DecoderCalValueTextBox2, "FS peak decoder output voltage")
        '
        'MobileOutCalFileTextBox1
        '
        Me.MobileOutCalFileTextBox1.Location = New System.Drawing.Point(152, 136)
        Me.MobileOutCalFileTextBox1.Name = "MobileOutCalFileTextBox1"
        Me.MobileOutCalFileTextBox1.ReadOnly = True
        Me.MobileOutCalFileTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.MobileOutCalFileTextBox1.TabIndex = 15
        Me.MobileOutCalFileTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.MobileOutCalFileTextBox1, "Path name for mobile output calibration file")
        '
        'MobileOutCalValueTextBox1
        '
        Me.MobileOutCalValueTextBox1.Location = New System.Drawing.Point(536, 136)
        Me.MobileOutCalValueTextBox1.Name = "MobileOutCalValueTextBox1"
        Me.MobileOutCalValueTextBox1.ReadOnly = True
        Me.MobileOutCalValueTextBox1.Size = New System.Drawing.Size(104, 21)
        Me.MobileOutCalValueTextBox1.TabIndex = 16
        Me.MobileOutCalValueTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.MobileOutCalValueTextBox1, "FS peak mobile output voltage")
        '
        'EncoderCalValueTextBox1
        '
        Me.EncoderCalValueTextBox1.Location = New System.Drawing.Point(536, 96)
        Me.EncoderCalValueTextBox1.Name = "EncoderCalValueTextBox1"
        Me.EncoderCalValueTextBox1.ReadOnly = True
        Me.EncoderCalValueTextBox1.Size = New System.Drawing.Size(104, 21)
        Me.EncoderCalValueTextBox1.TabIndex = 13
        Me.EncoderCalValueTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.EncoderCalValueTextBox1, "FS peak encoder input voltage")
        '
        'EncoderCalFileTextBox1
        '
        Me.EncoderCalFileTextBox1.Location = New System.Drawing.Point(152, 96)
        Me.EncoderCalFileTextBox1.Name = "EncoderCalFileTextBox1"
        Me.EncoderCalFileTextBox1.ReadOnly = True
        Me.EncoderCalFileTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.EncoderCalFileTextBox1.TabIndex = 12
        Me.EncoderCalFileTextBox1.Text = ""
        Me.ToolTip1.SetToolTip(Me.EncoderCalFileTextBox1, "Path name for encoder calibration file")
        '
        'DecoderCalFileTextBox2
        '
        Me.DecoderCalFileTextBox2.Location = New System.Drawing.Point(152, 56)
        Me.DecoderCalFileTextBox2.Name = "DecoderCalFileTextBox2"
        Me.DecoderCalFileTextBox2.ReadOnly = True
        Me.DecoderCalFileTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.DecoderCalFileTextBox2.TabIndex = 10
        Me.DecoderCalFileTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.DecoderCalFileTextBox2, "Path name for decoder calibration file")
        '
        'WavFileClearButton3
        '
        Me.WavFileClearButton3.Location = New System.Drawing.Point(536, 216)
        Me.WavFileClearButton3.Name = "WavFileClearButton3"
        Me.WavFileClearButton3.Size = New System.Drawing.Size(80, 23)
        Me.WavFileClearButton3.TabIndex = 30
        Me.WavFileClearButton3.Text = "Clear"
        Me.ToolTip1.SetToolTip(Me.WavFileClearButton3, "Load mobile input calibration from file")
        '
        'Label16
        '
        Me.Label16.Location = New System.Drawing.Point(16, 216)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(128, 23)
        Me.Label16.TabIndex = 29
        Me.Label16.Text = "Test Signal wav File"
        Me.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label16, "FS output voltage of mobile phone")
        '
        'WavFileBrowseButton3
        '
        Me.WavFileBrowseButton3.Location = New System.Drawing.Point(448, 216)
        Me.WavFileBrowseButton3.Name = "WavFileBrowseButton3"
        Me.WavFileBrowseButton3.Size = New System.Drawing.Size(80, 23)
        Me.WavFileBrowseButton3.TabIndex = 27
        Me.WavFileBrowseButton3.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.WavFileBrowseButton3, "Load mobile input calibration from file")
        '
        'WavFileTextBox3
        '
        Me.WavFileTextBox3.Location = New System.Drawing.Point(152, 216)
        Me.WavFileTextBox3.Name = "WavFileTextBox3"
        Me.WavFileTextBox3.ReadOnly = True
        Me.WavFileTextBox3.Size = New System.Drawing.Size(288, 21)
        Me.WavFileTextBox3.TabIndex = 28
        Me.WavFileTextBox3.Text = ""
        Me.ToolTip1.SetToolTip(Me.WavFileTextBox3, "Path name of test signal file")
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(224, 256)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(208, 23)
        Me.Label10.TabIndex = 23
        Me.Label10.Text = "dBFs (peak) of mobile input"
        Me.Label10.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label10, "FS output voltage of mobile phone")
        '
        'dBFSUpDown3
        '
        Me.dBFSUpDown3.DecimalPlaces = 1
        Me.dBFSUpDown3.Location = New System.Drawing.Point(152, 256)
        Me.dBFSUpDown3.Minimum = New Decimal(New Integer() {100, 0, 0, -2147483648})
        Me.dBFSUpDown3.Name = "dBFSUpDown3"
        Me.dBFSUpDown3.Size = New System.Drawing.Size(64, 21)
        Me.dBFSUpDown3.TabIndex = 22
        Me.dBFSUpDown3.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.dBFSUpDown3, "FS peak voltage of signal in terms of dBFS at the mobile input")
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(16, 256)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(128, 23)
        Me.Label11.TabIndex = 21
        Me.Label11.Text = "Set Fs of wav file to"
        Me.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label11, "FS output voltage of mobile phone")
        '
        'MobileInCalValueTextBox2
        '
        Me.MobileInCalValueTextBox2.Location = New System.Drawing.Point(536, 56)
        Me.MobileInCalValueTextBox2.Name = "MobileInCalValueTextBox2"
        Me.MobileInCalValueTextBox2.ReadOnly = True
        Me.MobileInCalValueTextBox2.Size = New System.Drawing.Size(104, 21)
        Me.MobileInCalValueTextBox2.TabIndex = 9
        Me.MobileInCalValueTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.MobileInCalValueTextBox2, "FS peak mobile input voltage")
        '
        'MobileOutCalValueTextBox2
        '
        Me.MobileOutCalValueTextBox2.Location = New System.Drawing.Point(536, 96)
        Me.MobileOutCalValueTextBox2.Name = "MobileOutCalValueTextBox2"
        Me.MobileOutCalValueTextBox2.ReadOnly = True
        Me.MobileOutCalValueTextBox2.Size = New System.Drawing.Size(104, 21)
        Me.MobileOutCalValueTextBox2.TabIndex = 12
        Me.MobileOutCalValueTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.MobileOutCalValueTextBox2, "FS peak mobile output voltage")
        '
        'EncoderCalButton2
        '
        Me.EncoderCalButton2.Location = New System.Drawing.Point(16, 96)
        Me.EncoderCalButton2.Name = "EncoderCalButton2"
        Me.EncoderCalButton2.Size = New System.Drawing.Size(128, 23)
        Me.EncoderCalButton2.TabIndex = 32
        Me.EncoderCalButton2.Text = "Encoder Cal."
        Me.ToolTip1.SetToolTip(Me.EncoderCalButton2, "Determines FS input voltage of system simulator and mobile output voltage")
        '
        'DecoderCalButton3
        '
        Me.DecoderCalButton3.Location = New System.Drawing.Point(16, 56)
        Me.DecoderCalButton3.Name = "DecoderCalButton3"
        Me.DecoderCalButton3.Size = New System.Drawing.Size(128, 23)
        Me.DecoderCalButton3.TabIndex = 31
        Me.DecoderCalButton3.Text = "Decoder Cal."
        Me.ToolTip1.SetToolTip(Me.DecoderCalButton3, "Measures FS output voltage of system simulator")
        '
        'WavFileClearButton4
        '
        Me.WavFileClearButton4.Location = New System.Drawing.Point(536, 216)
        Me.WavFileClearButton4.Name = "WavFileClearButton4"
        Me.WavFileClearButton4.Size = New System.Drawing.Size(80, 23)
        Me.WavFileClearButton4.TabIndex = 30
        Me.WavFileClearButton4.Text = "Clear"
        Me.ToolTip1.SetToolTip(Me.WavFileClearButton4, "Load mobile input calibration from file")
        '
        'Label17
        '
        Me.Label17.Location = New System.Drawing.Point(16, 216)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(128, 23)
        Me.Label17.TabIndex = 29
        Me.Label17.Text = "Test Signal wav File"
        Me.Label17.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label17, "FS output voltage of mobile phone")
        '
        'WavFileBrowseButton4
        '
        Me.WavFileBrowseButton4.Location = New System.Drawing.Point(448, 216)
        Me.WavFileBrowseButton4.Name = "WavFileBrowseButton4"
        Me.WavFileBrowseButton4.Size = New System.Drawing.Size(80, 23)
        Me.WavFileBrowseButton4.TabIndex = 27
        Me.WavFileBrowseButton4.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.WavFileBrowseButton4, "Load mobile input calibration from file")
        '
        'WavFileTextBox4
        '
        Me.WavFileTextBox4.Location = New System.Drawing.Point(152, 216)
        Me.WavFileTextBox4.Name = "WavFileTextBox4"
        Me.WavFileTextBox4.ReadOnly = True
        Me.WavFileTextBox4.Size = New System.Drawing.Size(288, 21)
        Me.WavFileTextBox4.TabIndex = 28
        Me.WavFileTextBox4.Text = ""
        Me.ToolTip1.SetToolTip(Me.WavFileTextBox4, "Path name of test signal file")
        '
        'Label12
        '
        Me.Label12.Location = New System.Drawing.Point(224, 256)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(208, 23)
        Me.Label12.TabIndex = 23
        Me.Label12.Text = "dBFs (peak) of encoder input"
        Me.Label12.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label12, "FS output voltage of mobile phone")
        '
        'dBFSUpDown4
        '
        Me.dBFSUpDown4.DecimalPlaces = 1
        Me.dBFSUpDown4.Location = New System.Drawing.Point(152, 256)
        Me.dBFSUpDown4.Minimum = New Decimal(New Integer() {100, 0, 0, -2147483648})
        Me.dBFSUpDown4.Name = "dBFSUpDown4"
        Me.dBFSUpDown4.Size = New System.Drawing.Size(64, 21)
        Me.dBFSUpDown4.TabIndex = 22
        Me.dBFSUpDown4.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.dBFSUpDown4, "FS peak voltage of signal in terms of dBFS at the encoder input")
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(16, 256)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(136, 23)
        Me.Label13.TabIndex = 21
        Me.Label13.Text = "Set Fs of wav file to"
        Me.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.ToolTip1.SetToolTip(Me.Label13, "FS output voltage of mobile phone")
        '
        'EncoderCalValueTextBox2
        '
        Me.EncoderCalValueTextBox2.Location = New System.Drawing.Point(536, 96)
        Me.EncoderCalValueTextBox2.Name = "EncoderCalValueTextBox2"
        Me.EncoderCalValueTextBox2.ReadOnly = True
        Me.EncoderCalValueTextBox2.Size = New System.Drawing.Size(104, 21)
        Me.EncoderCalValueTextBox2.TabIndex = 12
        Me.EncoderCalValueTextBox2.Text = ""
        Me.ToolTip1.SetToolTip(Me.EncoderCalValueTextBox2, "FS peak encoder input voltage")
        '
        'DecoderCalValueTextBox3
        '
        Me.DecoderCalValueTextBox3.Location = New System.Drawing.Point(536, 56)
        Me.DecoderCalValueTextBox3.Name = "DecoderCalValueTextBox3"
        Me.DecoderCalValueTextBox3.ReadOnly = True
        Me.DecoderCalValueTextBox3.Size = New System.Drawing.Size(104, 21)
        Me.DecoderCalValueTextBox3.TabIndex = 9
        Me.DecoderCalValueTextBox3.Text = ""
        Me.ToolTip1.SetToolTip(Me.DecoderCalValueTextBox3, "FS peak decoder output voltage")
        '
        'MISpeechCalButton
        '
        Me.MISpeechCalButton.Location = New System.Drawing.Point(16, 136)
        Me.MISpeechCalButton.Name = "MISpeechCalButton"
        Me.MISpeechCalButton.Size = New System.Drawing.Size(128, 23)
        Me.MISpeechCalButton.TabIndex = 28
        Me.MISpeechCalButton.Text = "M. I.  Speech Cal."
        Me.ToolTip1.SetToolTip(Me.MISpeechCalButton, "Measures FS decoder output voltage")
        '
        'GenFiltBrowseButton
        '
        Me.GenFiltBrowseButton.Location = New System.Drawing.Point(448, 336)
        Me.GenFiltBrowseButton.Name = "GenFiltBrowseButton"
        Me.GenFiltBrowseButton.Size = New System.Drawing.Size(80, 23)
        Me.GenFiltBrowseButton.TabIndex = 31
        Me.GenFiltBrowseButton.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.GenFiltBrowseButton, "Load mobile input calibration from file")
        '
        'GenFiltBrowseButton1
        '
        Me.GenFiltBrowseButton1.Location = New System.Drawing.Point(448, 336)
        Me.GenFiltBrowseButton1.Name = "GenFiltBrowseButton1"
        Me.GenFiltBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.GenFiltBrowseButton1.TabIndex = 34
        Me.GenFiltBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.GenFiltBrowseButton1, "Load mobile input calibration from file")
        '
        'AnFiltBrowseButton1
        '
        Me.AnFiltBrowseButton1.Location = New System.Drawing.Point(448, 376)
        Me.AnFiltBrowseButton1.Name = "AnFiltBrowseButton1"
        Me.AnFiltBrowseButton1.Size = New System.Drawing.Size(80, 23)
        Me.AnFiltBrowseButton1.TabIndex = 37
        Me.AnFiltBrowseButton1.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.AnFiltBrowseButton1, "Load mobile input calibration from file")
        '
        'AnFiltBrowseButton2
        '
        Me.AnFiltBrowseButton2.Location = New System.Drawing.Point(448, 376)
        Me.AnFiltBrowseButton2.Name = "AnFiltBrowseButton2"
        Me.AnFiltBrowseButton2.Size = New System.Drawing.Size(80, 23)
        Me.AnFiltBrowseButton2.TabIndex = 40
        Me.AnFiltBrowseButton2.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.AnFiltBrowseButton2, "Load mobile input calibration from file")
        '
        'UplinkIOSpeechCalButton
        '
        Me.UplinkIOSpeechCalButton.Location = New System.Drawing.Point(152, 176)
        Me.UplinkIOSpeechCalButton.Name = "UplinkIOSpeechCalButton"
        Me.UplinkIOSpeechCalButton.Size = New System.Drawing.Size(128, 23)
        Me.UplinkIOSpeechCalButton.TabIndex = 32
        Me.UplinkIOSpeechCalButton.Text = "In/Out Speech Cal."
        Me.ToolTip1.SetToolTip(Me.UplinkIOSpeechCalButton, "Alternative method using the input/output-curve")
        '
        'MobileOutCalButton
        '
        Me.MobileOutCalButton.Location = New System.Drawing.Point(16, 136)
        Me.MobileOutCalButton.Name = "MobileOutCalButton"
        Me.MobileOutCalButton.Size = New System.Drawing.Size(128, 23)
        Me.MobileOutCalButton.TabIndex = 41
        Me.MobileOutCalButton.Text = "Mobile Outp. Cal."
        Me.ToolTip1.SetToolTip(Me.MobileOutCalButton, "Determines FS input voltage of system simulator and mobile output voltage")
        '
        'DownlinkIOSpeechCalButton
        '
        Me.DownlinkIOSpeechCalButton.Location = New System.Drawing.Point(152, 176)
        Me.DownlinkIOSpeechCalButton.Name = "DownlinkIOSpeechCalButton"
        Me.DownlinkIOSpeechCalButton.Size = New System.Drawing.Size(128, 23)
        Me.DownlinkIOSpeechCalButton.TabIndex = 43
        Me.DownlinkIOSpeechCalButton.Text = "In/Out Speech Cal."
        Me.ToolTip1.SetToolTip(Me.DownlinkIOSpeechCalButton, "Alternative method using the input/output-curve")
        '
        'NetworkLoopSpeechCalButton
        '
        Me.NetworkLoopSpeechCalButton.Location = New System.Drawing.Point(152, 136)
        Me.NetworkLoopSpeechCalButton.Name = "NetworkLoopSpeechCalButton"
        Me.NetworkLoopSpeechCalButton.Size = New System.Drawing.Size(128, 23)
        Me.NetworkLoopSpeechCalButton.TabIndex = 39
        Me.NetworkLoopSpeechCalButton.Text = "In/Out Speech Cal."
        Me.ToolTip1.SetToolTip(Me.NetworkLoopSpeechCalButton, "Alternative method using the input/output-curve")
        '
        'MobileLoopSpeechCalButton
        '
        Me.MobileLoopSpeechCalButton.Location = New System.Drawing.Point(152, 136)
        Me.MobileLoopSpeechCalButton.Name = "MobileLoopSpeechCalButton"
        Me.MobileLoopSpeechCalButton.Size = New System.Drawing.Size(128, 23)
        Me.MobileLoopSpeechCalButton.TabIndex = 37
        Me.MobileLoopSpeechCalButton.Text = "In/Out Speech Cal."
        Me.ToolTip1.SetToolTip(Me.MobileLoopSpeechCalButton, "Alternative method using the input/output-curve")
        '
        'TabControl1
        '
        Me.TabControl1.Controls.Add(Me.TabPage1)
        Me.TabControl1.Controls.Add(Me.TabPage3)
        Me.TabControl1.Controls.Add(Me.TabPage2)
        Me.TabControl1.Controls.Add(Me.TabPage4)
        Me.TabControl1.Location = New System.Drawing.Point(8, 8)
        Me.TabControl1.Name = "TabControl1"
        Me.TabControl1.SelectedIndex = 0
        Me.TabControl1.Size = New System.Drawing.Size(664, 440)
        Me.TabControl1.TabIndex = 0
        '
        'TabPage1
        '
        Me.TabPage1.Controls.Add(Me.FSCheckBox1)
        Me.TabPage1.Controls.Add(Me.GroupBox1)
        Me.TabPage1.Controls.Add(Me.UplinkIOSpeechCalButton)
        Me.TabPage1.Controls.Add(Me.GenFiltBrowseButton)
        Me.TabPage1.Controls.Add(Me.GenFiltTextBox)
        Me.TabPage1.Controls.Add(Me.GenFiltCheckBox)
        Me.TabPage1.Controls.Add(Me.MISpeechCalButton)
        Me.TabPage1.Controls.Add(Me.WavFileClearButton1)
        Me.TabPage1.Controls.Add(Me.Label14)
        Me.TabPage1.Controls.Add(Me.WavFileBrowseButton1)
        Me.TabPage1.Controls.Add(Me.WavFileTextBox1)
        Me.TabPage1.Controls.Add(Me.Label8)
        Me.TabPage1.Controls.Add(Me.dBFSUpDown1)
        Me.TabPage1.Controls.Add(Me.Label9)
        Me.TabPage1.Controls.Add(Me.ShowUplinkInstructionsButton)
        Me.TabPage1.Controls.Add(Me.ShowUplinkSchematicButton)
        Me.TabPage1.Controls.Add(Me.UplinkSetupBrowseButton)
        Me.TabPage1.Controls.Add(Me.MobileInCalBrowseButton1)
        Me.TabPage1.Controls.Add(Me.DecoderCalButton1)
        Me.TabPage1.Controls.Add(Me.UplinkIOCalButton)
        Me.TabPage1.Controls.Add(Me.MobileInCalFileTextBox1)
        Me.TabPage1.Controls.Add(Me.DecoderCalValueTextBox1)
        Me.TabPage1.Controls.Add(Me.DecoderCalFileTextBox1)
        Me.TabPage1.Controls.Add(Me.DecoderCalBrowseButton1)
        Me.TabPage1.Controls.Add(Me.UplinkSetupTextBox)
        Me.TabPage1.Controls.Add(Me.MobileInCalValueTextBox1)
        Me.TabPage1.Controls.Add(Me.MobileInCalButton)
        Me.TabPage1.Controls.Add(Me.UplinkSetupLoadButton)
        Me.TabPage1.Location = New System.Drawing.Point(4, 22)
        Me.TabPage1.Name = "TabPage1"
        Me.TabPage1.Size = New System.Drawing.Size(656, 414)
        Me.TabPage1.TabIndex = 0
        Me.TabPage1.Text = "Uplink"
        '
        'FSCheckBox1
        '
        Me.FSCheckBox1.Location = New System.Drawing.Point(448, 256)
        Me.FSCheckBox1.Name = "FSCheckBox1"
        Me.FSCheckBox1.Size = New System.Drawing.Size(168, 24)
        Me.FSCheckBox1.TabIndex = 35
        Me.FSCheckBox1.Text = "Scale Peak to Full Scale"
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.Add(Me.RadioButton26)
        Me.GroupBox1.Controls.Add(Me.RadioButton16)
        Me.GroupBox1.Location = New System.Drawing.Point(152, 120)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(288, 48)
        Me.GroupBox1.TabIndex = 34
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Calibration Level"
        '
        'RadioButton26
        '
        Me.RadioButton26.Location = New System.Drawing.Point(168, 16)
        Me.RadioButton26.Name = "RadioButton26"
        Me.RadioButton26.TabIndex = 1
        Me.RadioButton26.Text = "-26 dBm0"
        '
        'RadioButton16
        '
        Me.RadioButton16.Checked = True
        Me.RadioButton16.Location = New System.Drawing.Point(32, 16)
        Me.RadioButton16.Name = "RadioButton16"
        Me.RadioButton16.TabIndex = 0
        Me.RadioButton16.TabStop = True
        Me.RadioButton16.Text = "-16 dBm0"
        '
        'GenFiltTextBox
        '
        Me.GenFiltTextBox.Location = New System.Drawing.Point(152, 336)
        Me.GenFiltTextBox.Name = "GenFiltTextBox"
        Me.GenFiltTextBox.ReadOnly = True
        Me.GenFiltTextBox.Size = New System.Drawing.Size(288, 21)
        Me.GenFiltTextBox.TabIndex = 30
        Me.GenFiltTextBox.Text = ""
        '
        'GenFiltCheckBox
        '
        Me.GenFiltCheckBox.Location = New System.Drawing.Point(16, 336)
        Me.GenFiltCheckBox.Name = "GenFiltCheckBox"
        Me.GenFiltCheckBox.Size = New System.Drawing.Size(144, 24)
        Me.GenFiltCheckBox.TabIndex = 29
        Me.GenFiltCheckBox.Text = "Use Generator Filter"
        '
        'MobileInCalFileTextBox1
        '
        Me.MobileInCalFileTextBox1.Location = New System.Drawing.Point(152, 96)
        Me.MobileInCalFileTextBox1.Name = "MobileInCalFileTextBox1"
        Me.MobileInCalFileTextBox1.ReadOnly = True
        Me.MobileInCalFileTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.MobileInCalFileTextBox1.TabIndex = 11
        Me.MobileInCalFileTextBox1.Text = ""
        '
        'DecoderCalFileTextBox1
        '
        Me.DecoderCalFileTextBox1.Location = New System.Drawing.Point(152, 56)
        Me.DecoderCalFileTextBox1.Name = "DecoderCalFileTextBox1"
        Me.DecoderCalFileTextBox1.ReadOnly = True
        Me.DecoderCalFileTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.DecoderCalFileTextBox1.TabIndex = 9
        Me.DecoderCalFileTextBox1.Text = ""
        '
        'UplinkSetupTextBox
        '
        Me.UplinkSetupTextBox.Location = New System.Drawing.Point(152, 296)
        Me.UplinkSetupTextBox.Name = "UplinkSetupTextBox"
        Me.UplinkSetupTextBox.ReadOnly = True
        Me.UplinkSetupTextBox.Size = New System.Drawing.Size(288, 21)
        Me.UplinkSetupTextBox.TabIndex = 13
        Me.UplinkSetupTextBox.Text = ""
        '
        'TabPage2
        '
        Me.TabPage2.Controls.Add(Me.DownlinkIOSpeechCalButton)
        Me.TabPage2.Controls.Add(Me.FSCheckBox2)
        Me.TabPage2.Controls.Add(Me.MobileOutCalButton)
        Me.TabPage2.Controls.Add(Me.AnFiltBrowseButton2)
        Me.TabPage2.Controls.Add(Me.AnFiltTextBox2)
        Me.TabPage2.Controls.Add(Me.AnFiltCheckBox2)
        Me.TabPage2.Controls.Add(Me.WavFileClearButton2)
        Me.TabPage2.Controls.Add(Me.Label15)
        Me.TabPage2.Controls.Add(Me.WavFileBrowseButton2)
        Me.TabPage2.Controls.Add(Me.WavFileTextBox2)
        Me.TabPage2.Controls.Add(Me.Label7)
        Me.TabPage2.Controls.Add(Me.dBFSUpDown2)
        Me.TabPage2.Controls.Add(Me.Label6)
        Me.TabPage2.Controls.Add(Me.ShowDownlinkInstructionsButton)
        Me.TabPage2.Controls.Add(Me.ShowDownlinkSchematicButton)
        Me.TabPage2.Controls.Add(Me.DownlinkSetupBrowseButton)
        Me.TabPage2.Controls.Add(Me.DecoderCalValueTextBox2)
        Me.TabPage2.Controls.Add(Me.DownlinkSetupTextBox)
        Me.TabPage2.Controls.Add(Me.MobileOutCalFileTextBox1)
        Me.TabPage2.Controls.Add(Me.DownlinkSetupLoadButton)
        Me.TabPage2.Controls.Add(Me.MobileOutCalValueTextBox1)
        Me.TabPage2.Controls.Add(Me.DecoderCalButton32)
        Me.TabPage2.Controls.Add(Me.EncoderCalButton1)
        Me.TabPage2.Controls.Add(Me.EncoderCalValueTextBox1)
        Me.TabPage2.Controls.Add(Me.DecoderCalBrowseButton2)
        Me.TabPage2.Controls.Add(Me.DownlinkIOCalButton)
        Me.TabPage2.Controls.Add(Me.MobileOutCalBrowseButton1)
        Me.TabPage2.Controls.Add(Me.EncoderCalBrowseButton1)
        Me.TabPage2.Controls.Add(Me.EncoderCalFileTextBox1)
        Me.TabPage2.Controls.Add(Me.DecoderCalFileTextBox2)
        Me.TabPage2.Location = New System.Drawing.Point(4, 22)
        Me.TabPage2.Name = "TabPage2"
        Me.TabPage2.Size = New System.Drawing.Size(656, 414)
        Me.TabPage2.TabIndex = 1
        Me.TabPage2.Text = "Downlink"
        '
        'FSCheckBox2
        '
        Me.FSCheckBox2.Location = New System.Drawing.Point(448, 256)
        Me.FSCheckBox2.Name = "FSCheckBox2"
        Me.FSCheckBox2.Size = New System.Drawing.Size(168, 24)
        Me.FSCheckBox2.TabIndex = 42
        Me.FSCheckBox2.Text = "Scale Peak to Full Scale"
        '
        'AnFiltTextBox2
        '
        Me.AnFiltTextBox2.Location = New System.Drawing.Point(152, 376)
        Me.AnFiltTextBox2.Name = "AnFiltTextBox2"
        Me.AnFiltTextBox2.ReadOnly = True
        Me.AnFiltTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.AnFiltTextBox2.TabIndex = 39
        Me.AnFiltTextBox2.Text = ""
        '
        'AnFiltCheckBox2
        '
        Me.AnFiltCheckBox2.Location = New System.Drawing.Point(16, 376)
        Me.AnFiltCheckBox2.Name = "AnFiltCheckBox2"
        Me.AnFiltCheckBox2.Size = New System.Drawing.Size(144, 24)
        Me.AnFiltCheckBox2.TabIndex = 38
        Me.AnFiltCheckBox2.Text = "Use Analyzer Filter"
        '
        'DownlinkSetupTextBox
        '
        Me.DownlinkSetupTextBox.Location = New System.Drawing.Point(152, 296)
        Me.DownlinkSetupTextBox.Name = "DownlinkSetupTextBox"
        Me.DownlinkSetupTextBox.ReadOnly = True
        Me.DownlinkSetupTextBox.Size = New System.Drawing.Size(288, 21)
        Me.DownlinkSetupTextBox.TabIndex = 17
        Me.DownlinkSetupTextBox.Text = ""
        '
        'TabPage3
        '
        Me.TabPage3.Controls.Add(Me.NetworkLoopSpeechCalButton)
        Me.TabPage3.Controls.Add(Me.FSCheckBox3)
        Me.TabPage3.Controls.Add(Me.AnFiltBrowseButton1)
        Me.TabPage3.Controls.Add(Me.AnFiltTextBox1)
        Me.TabPage3.Controls.Add(Me.AnFiltCheckBox1)
        Me.TabPage3.Controls.Add(Me.GenFiltBrowseButton1)
        Me.TabPage3.Controls.Add(Me.GenFiltTextBox1)
        Me.TabPage3.Controls.Add(Me.GenFiltCheckBox1)
        Me.TabPage3.Controls.Add(Me.WavFileClearButton3)
        Me.TabPage3.Controls.Add(Me.Label16)
        Me.TabPage3.Controls.Add(Me.WavFileBrowseButton3)
        Me.TabPage3.Controls.Add(Me.WavFileTextBox3)
        Me.TabPage3.Controls.Add(Me.Label10)
        Me.TabPage3.Controls.Add(Me.dBFSUpDown3)
        Me.TabPage3.Controls.Add(Me.Label11)
        Me.TabPage3.Controls.Add(Me.ShowNetworkLoopInstructionsButton)
        Me.TabPage3.Controls.Add(Me.ShowNetworkLoopSchematicButton)
        Me.TabPage3.Controls.Add(Me.NetworkLoopBrowseButton)
        Me.TabPage3.Controls.Add(Me.MobileInCalFileTextBox2)
        Me.TabPage3.Controls.Add(Me.MobileInCalValueTextBox2)
        Me.TabPage3.Controls.Add(Me.Label2)
        Me.TabPage3.Controls.Add(Me.MobileOutCalValueTextBox2)
        Me.TabPage3.Controls.Add(Me.NetworkLoopSetupTextBox)
        Me.TabPage3.Controls.Add(Me.NetworkLoopSetupLoadButton)
        Me.TabPage3.Controls.Add(Me.Label3)
        Me.TabPage3.Controls.Add(Me.MobileInCalBrowseButton2)
        Me.TabPage3.Controls.Add(Me.MobileOutCalFileTextBox2)
        Me.TabPage3.Controls.Add(Me.NetworkLoopIOCalButton)
        Me.TabPage3.Controls.Add(Me.MobileOutCalBrowseButton2)
        Me.TabPage3.Location = New System.Drawing.Point(4, 22)
        Me.TabPage3.Name = "TabPage3"
        Me.TabPage3.Size = New System.Drawing.Size(656, 414)
        Me.TabPage3.TabIndex = 2
        Me.TabPage3.Text = "Loopback on Network Side"
        '
        'FSCheckBox3
        '
        Me.FSCheckBox3.Location = New System.Drawing.Point(448, 256)
        Me.FSCheckBox3.Name = "FSCheckBox3"
        Me.FSCheckBox3.Size = New System.Drawing.Size(168, 24)
        Me.FSCheckBox3.TabIndex = 38
        Me.FSCheckBox3.Text = "Scale Peak to Full Scale"
        '
        'AnFiltTextBox1
        '
        Me.AnFiltTextBox1.Location = New System.Drawing.Point(152, 376)
        Me.AnFiltTextBox1.Name = "AnFiltTextBox1"
        Me.AnFiltTextBox1.ReadOnly = True
        Me.AnFiltTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.AnFiltTextBox1.TabIndex = 36
        Me.AnFiltTextBox1.Text = ""
        '
        'AnFiltCheckBox1
        '
        Me.AnFiltCheckBox1.Location = New System.Drawing.Point(16, 376)
        Me.AnFiltCheckBox1.Name = "AnFiltCheckBox1"
        Me.AnFiltCheckBox1.Size = New System.Drawing.Size(144, 24)
        Me.AnFiltCheckBox1.TabIndex = 35
        Me.AnFiltCheckBox1.Text = "Use Analyzer Filter"
        '
        'GenFiltTextBox1
        '
        Me.GenFiltTextBox1.Location = New System.Drawing.Point(152, 336)
        Me.GenFiltTextBox1.Name = "GenFiltTextBox1"
        Me.GenFiltTextBox1.ReadOnly = True
        Me.GenFiltTextBox1.Size = New System.Drawing.Size(288, 21)
        Me.GenFiltTextBox1.TabIndex = 33
        Me.GenFiltTextBox1.Text = ""
        '
        'GenFiltCheckBox1
        '
        Me.GenFiltCheckBox1.Location = New System.Drawing.Point(16, 336)
        Me.GenFiltCheckBox1.Name = "GenFiltCheckBox1"
        Me.GenFiltCheckBox1.Size = New System.Drawing.Size(144, 24)
        Me.GenFiltCheckBox1.TabIndex = 32
        Me.GenFiltCheckBox1.Text = "Use Generator Filter"
        '
        'MobileInCalFileTextBox2
        '
        Me.MobileInCalFileTextBox2.Location = New System.Drawing.Point(152, 56)
        Me.MobileInCalFileTextBox2.Name = "MobileInCalFileTextBox2"
        Me.MobileInCalFileTextBox2.ReadOnly = True
        Me.MobileInCalFileTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.MobileInCalFileTextBox2.TabIndex = 8
        Me.MobileInCalFileTextBox2.Text = ""
        '
        'NetworkLoopSetupTextBox
        '
        Me.NetworkLoopSetupTextBox.Location = New System.Drawing.Point(152, 296)
        Me.NetworkLoopSetupTextBox.Name = "NetworkLoopSetupTextBox"
        Me.NetworkLoopSetupTextBox.ReadOnly = True
        Me.NetworkLoopSetupTextBox.Size = New System.Drawing.Size(288, 21)
        Me.NetworkLoopSetupTextBox.TabIndex = 13
        Me.NetworkLoopSetupTextBox.Text = ""
        '
        'MobileOutCalFileTextBox2
        '
        Me.MobileOutCalFileTextBox2.Location = New System.Drawing.Point(152, 96)
        Me.MobileOutCalFileTextBox2.Name = "MobileOutCalFileTextBox2"
        Me.MobileOutCalFileTextBox2.ReadOnly = True
        Me.MobileOutCalFileTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.MobileOutCalFileTextBox2.TabIndex = 11
        Me.MobileOutCalFileTextBox2.Text = ""
        '
        'TabPage4
        '
        Me.TabPage4.Controls.Add(Me.MobileLoopSpeechCalButton)
        Me.TabPage4.Controls.Add(Me.FSCheckBox4)
        Me.TabPage4.Controls.Add(Me.EncoderCalButton2)
        Me.TabPage4.Controls.Add(Me.DecoderCalButton3)
        Me.TabPage4.Controls.Add(Me.WavFileClearButton4)
        Me.TabPage4.Controls.Add(Me.Label17)
        Me.TabPage4.Controls.Add(Me.WavFileBrowseButton4)
        Me.TabPage4.Controls.Add(Me.WavFileTextBox4)
        Me.TabPage4.Controls.Add(Me.Label12)
        Me.TabPage4.Controls.Add(Me.dBFSUpDown4)
        Me.TabPage4.Controls.Add(Me.Label13)
        Me.TabPage4.Controls.Add(Me.ShowMobileLoopInstructionsButton)
        Me.TabPage4.Controls.Add(Me.ShowMobileLoopSchematicButton)
        Me.TabPage4.Controls.Add(Me.MobileLoopBrowseButton)
        Me.TabPage4.Controls.Add(Me.EncoderCalValueTextBox2)
        Me.TabPage4.Controls.Add(Me.MobileLoopSetupLoadButton)
        Me.TabPage4.Controls.Add(Me.DecoderCalValueTextBox3)
        Me.TabPage4.Controls.Add(Me.MobileLoopSetupTextBox)
        Me.TabPage4.Controls.Add(Me.MobileLoopIOCalButton)
        Me.TabPage4.Controls.Add(Me.EncoderCalFileTextBox2)
        Me.TabPage4.Controls.Add(Me.EncoderCalBrowseButton2)
        Me.TabPage4.Controls.Add(Me.DecoderCalFileTextBox3)
        Me.TabPage4.Controls.Add(Me.DecoderCalBrowseButton3)
        Me.TabPage4.Location = New System.Drawing.Point(4, 22)
        Me.TabPage4.Name = "TabPage4"
        Me.TabPage4.Size = New System.Drawing.Size(656, 414)
        Me.TabPage4.TabIndex = 3
        Me.TabPage4.Text = "Loopback on Mobile Side"
        '
        'FSCheckBox4
        '
        Me.FSCheckBox4.Location = New System.Drawing.Point(448, 256)
        Me.FSCheckBox4.Name = "FSCheckBox4"
        Me.FSCheckBox4.Size = New System.Drawing.Size(168, 24)
        Me.FSCheckBox4.TabIndex = 36
        Me.FSCheckBox4.Text = "Scale Peak to Full Scale"
        '
        'MobileLoopSetupTextBox
        '
        Me.MobileLoopSetupTextBox.Location = New System.Drawing.Point(152, 296)
        Me.MobileLoopSetupTextBox.Name = "MobileLoopSetupTextBox"
        Me.MobileLoopSetupTextBox.ReadOnly = True
        Me.MobileLoopSetupTextBox.Size = New System.Drawing.Size(288, 21)
        Me.MobileLoopSetupTextBox.TabIndex = 13
        Me.MobileLoopSetupTextBox.Text = ""
        '
        'EncoderCalFileTextBox2
        '
        Me.EncoderCalFileTextBox2.Location = New System.Drawing.Point(152, 96)
        Me.EncoderCalFileTextBox2.Name = "EncoderCalFileTextBox2"
        Me.EncoderCalFileTextBox2.ReadOnly = True
        Me.EncoderCalFileTextBox2.Size = New System.Drawing.Size(288, 21)
        Me.EncoderCalFileTextBox2.TabIndex = 8
        Me.EncoderCalFileTextBox2.Text = ""
        '
        'DecoderCalFileTextBox3
        '
        Me.DecoderCalFileTextBox3.Location = New System.Drawing.Point(152, 56)
        Me.DecoderCalFileTextBox3.Name = "DecoderCalFileTextBox3"
        Me.DecoderCalFileTextBox3.ReadOnly = True
        Me.DecoderCalFileTextBox3.Size = New System.Drawing.Size(288, 21)
        Me.DecoderCalFileTextBox3.TabIndex = 11
        Me.DecoderCalFileTextBox3.Text = ""
        '
        'MinimizeCheckBox
        '
        Me.MinimizeCheckBox.Checked = True
        Me.MinimizeCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.MinimizeCheckBox.Location = New System.Drawing.Point(16, 456)
        Me.MinimizeCheckBox.Name = "MinimizeCheckBox"
        Me.MinimizeCheckBox.Size = New System.Drawing.Size(192, 24)
        Me.MinimizeCheckBox.TabIndex = 1
        Me.MinimizeCheckBox.Text = "Minimize After Loading Setup"
        '
        'StartCheckBox
        '
        Me.StartCheckBox.Checked = True
        Me.StartCheckBox.CheckState = System.Windows.Forms.CheckState.Checked
        Me.StartCheckBox.Location = New System.Drawing.Point(16, 480)
        Me.StartCheckBox.Name = "StartCheckBox"
        Me.StartCheckBox.Size = New System.Drawing.Size(256, 24)
        Me.StartCheckBox.TabIndex = 3
        Me.StartCheckBox.Text = "Start Measurement After Loading Setup"
        '
        'ClearButton
        '
        Me.ClearButton.Location = New System.Drawing.Point(448, 464)
        Me.ClearButton.Name = "ClearButton"
        Me.ClearButton.Size = New System.Drawing.Size(104, 23)
        Me.ClearButton.TabIndex = 4
        Me.ClearButton.Text = "Clear All Values"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
        Me.ClientSize = New System.Drawing.Size(680, 509)
        Me.Controls.Add(Me.ClearButton)
        Me.Controls.Add(Me.StartCheckBox)
        Me.Controls.Add(Me.MinimizeCheckBox)
        Me.Controls.Add(Me.TabControl1)
        Me.Controls.Add(Me.CloseButton)
        Me.Font = New System.Drawing.Font("Verdana", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Input and output calibration for PESQ"
        CType(Me.dBFSUpDown1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.dBFSUpDown2, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.dBFSUpDown3, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.dBFSUpDown4, System.ComponentModel.ISupportInitialize).EndInit()
        Me.TabControl1.ResumeLayout(False)
        Me.TabPage1.ResumeLayout(False)
        Me.GroupBox1.ResumeLayout(False)
        Me.TabPage2.ResumeLayout(False)
        Me.TabPage3.ResumeLayout(False)
        Me.TabPage4.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region " Settings "
    Private Sub LoadSettings()
        Dim FileName As String = WorkingDir & "\setup.set"
        Dim Instring As String

        Try
            If File.Exists(FileName) Then
                FileOpen(1, FileName, OpenMode.Input)
                If LineInput(1) = "UPV_1GA50_SETUP" Then
                    Instring = LineInput(1)
                    DecoderCalFileTextBox1.Text = Instring
                    DecoderCalFileTextBox2.Text = Instring
                    DecoderCalFileTextBox3.Text = Instring
                    Instring = LineInput(1)
                    If Not Instring = String.Empty Then
                        DecoderCalValue = Val(Instring)
                        DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                        DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                        DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                    End If
                    Instring = LineInput(1)
                    EncoderCalFileTextBox1.Text = Instring
                    EncoderCalFileTextBox2.Text = Instring
                    Instring = LineInput(1)
                    If Not Instring = String.Empty Then
                        EncoderCalValue = Val(Instring)
                        EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                        EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                    End If
                    Instring = LineInput(1)
                    MobileInCalFileTextBox1.Text = Instring
                    MobileInCalFileTextBox2.Text = Instring
                    Instring = LineInput(1)
                    If Not Instring = String.Empty Then
                        MobileInCalValue = Val(Instring)
                        MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                        MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                    End If
                    Instring = LineInput(1)
                    MobileOutCalFileTextBox1.Text = Instring
                    MobileOutCalFileTextBox2.Text = Instring
                    Instring = LineInput(1)
                    If Not Instring = String.Empty Then
                        MobileOutCalValue = Val(Instring)
                        MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                        MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                    End If
                    UplinkSetupTextBox.Text = LineInput(1)
                    DownlinkSetupTextBox.Text = LineInput(1)
                    NetworkLoopSetupTextBox.Text = LineInput(1)
                    MobileLoopSetupTextBox.Text = LineInput(1)
                    WavFileTextBox1.Text = LineInput(1)
                    WavFileTextBox2.Text = WavFileTextBox1.Text
                    WavFileTextBox3.Text = WavFileTextBox1.Text
                    WavFileTextBox4.Text = WavFileTextBox1.Text
                    Instring = LineInput(1)
                    dBFSUpDown1.Value = Val(Instring)
                    dBFSUpDown2.Value = Val(Instring)
                    dBFSUpDown3.Value = Val(Instring)
                    dBFSUpDown4.Value = Val(Instring)
                    Instring = LineInput(1)
                    MinimizeCheckBox.Checked = (Val(Instring) = 1)
                    Instring = LineInput(1)
                    StartCheckBox.Checked = (Val(Instring) = 1)
                    If Not EOF(1) Then
                        Instring = LineInput(1)
                        RadioButton26.Checked = (Val(Instring) = 1)
                        GenFiltTextBox.Text = LineInput(1)
                        Instring = LineInput(1)
                        GenFiltCheckBox.Checked = (Val(Instring) = 1)
                        AnFiltTextBox1.Text = LineInput(1)
                        Instring = LineInput(1)
                        AnFiltCheckBox1.Checked = (Val(Instring) = 1)
                        Instring = LineInput(1)
                        TabControl1.SelectedIndex = Val(Instring)
                        If Not EOF(1) Then
                            Instring = LineInput(1)
                            FSCheckBox1.Checked = (Val(Instring) = 1)
                        End If
                    End If
                End If
                FileClose(1)
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose()
        End Try
    End Sub

    Private Sub SaveSettings()
        Dim FileName As String = WorkingDir & "\setup.set"

        Try
            If File.Exists(WorkingDir & "\setup.set") Then File.Delete(WorkingDir & "\setup.set")
            FileOpen(2, FileName, OpenMode.Output)
            PrintLine(2, "UPV_1GA50_SETUP")
            PrintLine(2, DecoderCalFileTextBox1.Text)
            If Not DecoderCalValue = NaN Then
                PrintLine(2, DecoderCalValue.ToString)
            Else
                PrintLine(2, "")
            End If
            PrintLine(2, EncoderCalFileTextBox1.Text)
            If Not EncoderCalValue = NaN Then
                PrintLine(2, EncoderCalValue.ToString)
            Else
                PrintLine(2, "")
            End If
            PrintLine(2, MobileInCalFileTextBox1.Text)
            If Not MobileInCalValue = NaN Then
                PrintLine(2, MobileInCalValue.ToString)
            Else
                PrintLine(2, "")
            End If
            PrintLine(2, MobileOutCalFileTextBox1.Text)
            If Not MobileOutCalValue = NaN Then
                PrintLine(2, MobileOutCalValue.ToString)
            Else
                PrintLine(2, "")
            End If
            PrintLine(2, UplinkSetupTextBox.Text)
            PrintLine(2, DownlinkSetupTextBox.Text)
            PrintLine(2, NetworkLoopSetupTextBox.Text)
            PrintLine(2, MobileLoopSetupTextBox.Text)
            PrintLine(2, WavFileTextBox1.Text)
            PrintLine(2, dBFSUpDown1.Value.ToString)
            If MinimizeCheckBox.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
            If StartCheckBox.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
            If RadioButton26.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
            PrintLine(2, GenFiltTextBox.Text)
            If GenFiltCheckBox.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
            PrintLine(2, AnFiltTextBox1.Text)
            If AnFiltCheckBox1.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
            PrintLine(2, TabControl1.SelectedIndex.ToString)
            If FSCheckBox1.Checked Then
                PrintLine(2, "1")
            Else
                PrintLine(2, "0")
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose()
        End Try
    End Sub

#End Region

#Region " File Operations "

    Private Sub StoreCalFile(ByVal FileName As String, ByVal CalValue As Double, ByVal CalType As String)
        Try

            If File.Exists(FileName) Then File.Delete(FileName)
            FileOpen(4, FileName, OpenMode.Output)
            PrintLine(4, "UPV_1GA50_CAL")
            PrintLine(4, CalType)
            PrintLine(4, CalValue.ToString("#.######"))
            FileClose(4)
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose(4)
        End Try
    End Sub

    Private Sub StoreCalFile(ByVal FileName As String, ByVal CalValue As Double, ByVal CalType As String, ByVal FilterFile As String)
        Try

            If File.Exists(FileName) Then File.Delete(FileName)
            FileOpen(4, FileName, OpenMode.Output)
            PrintLine(4, "UPV_1GA50_CAL")
            PrintLine(4, CalType)
            PrintLine(4, CalValue.ToString("#.######"))
            If Not FilterFile = String.Empty Then PrintLine(4, FilterFile)
            FileClose(4)
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose(4)
        End Try
    End Sub

    Private Sub StoreCurve(ByVal FileName As String, ByVal XValues() As Double, ByVal YValues() As Double)
        Dim Index As Integer

        Try
            If File.Exists(FileName) Then File.Delete(FileName)
            FileOpen(4, FileName, OpenMode.Output)
            PrintLine(4, "I/O Curve")
            PrintLine(4, "X,Y")
            For Index = 0 To XValues.Length - 1
                PrintLine(4, XValues(Index).ToString("0.###") & "," & YValues(Index).ToString("0.###"))
            Next
            FileClose(4)
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose(4)
        End Try
    End Sub

    Private Function LoadCalFile(ByVal FileName As String, ByVal CalType As String, ByRef FilterFile As String) As Double
        Dim Instring As String
        Dim Result As Double = NaN

        Try
            If File.Exists(FileName) Then
                FileOpen(4, FileName, OpenMode.Input)
                If LineInput(4) = "UPV_1GA50_CAL" Then
                    If LineInput(4) = CalType Then
                        Instring = LineInput(4)
                        Result = Val(Instring)
                        Select Case CalType
                            Case "mobile_in"
                                FilterFile = LineInput(4)
                        End Select
                    Else
                        MessageBox.Show("This file does not match the type of calibration value.", "Input and Output Calibration for PESQ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                Else
                    MessageBox.Show("This file is not a valid calibration file.", "Input and Output Calibration for PESQ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
                FileClose(4)
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            FileClose(4)
        End Try
        Return Result
    End Function

    Private Function ReadVersionFile() As String
        Dim Result As String = String.Empty

        Try
            If File.Exists(WorkingDir & "\Version.Inf") Then
                FileOpen(4, WorkingDir & "\Version.Inf", OpenMode.Input)
                If LineInput(4) = "UPV_1GA50_VER" Then
                    Result = LineInput(4)
                End If
                FileClose(4)
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Error while reading version file.", "Input and Output Calibration for PESQ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
        Return Result
    End Function

    Private Sub WriteVersionFile()
        Try
            If File.Exists(WorkingDir & "\Version.Inf") Then File.Delete(WorkingDir & "\Version.Inf")
            FileOpen(4, WorkingDir & "\Version.Inf", OpenMode.Output)
            PrintLine(4, "UPV_1GA50_VER")
            PrintLine(4, Version)
            FileClose(4)
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Error while writing version file.", "Input and Output Calibration for PESQ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

#End Region

#Region " Start and End of Program "

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim OriginalFile As String
        Dim DestinationFile As String
        Dim OldDirectory As Boolean = True
        Dim Update As Boolean = False

        If Not Directory.Exists(WorkingDir) Then                'create working directory
            Directory.CreateDirectory(WorkingDir)
            For Each OriginalFile In Directory.GetFiles(ProgramDir & "\Files")
                DestinationFile = WorkingDir & "\" & OriginalFile.Substring(OriginalFile.LastIndexOf("\"c) + 1)
                Debug.WriteLine("OriginalFile = " & OriginalFile & "  DestinationFile = " & DestinationFile)
                File.Copy(OriginalFile, DestinationFile)
            Next
            WriteVersionFile()
        Else
            If File.Exists(WorkingDir & "\Version.Inf") Then
                If ReadVersionFile() = Version Then OldDirectory = False
            End If
            If OldDirectory Then
                If MessageBox.Show("Old version of working directory detected. Do you want to update (recommended)?", "Input and Output Calibration for PESQ", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                    For Each OriginalFile In Directory.GetFiles(ProgramDir & "\Files")
                        DestinationFile = WorkingDir & "\" & OriginalFile.Substring(OriginalFile.LastIndexOf("\"c) + 1)
                        Debug.WriteLine("OriginalFile = " & OriginalFile & "  DestinationFile = " & DestinationFile)
                        File.Copy(OriginalFile, DestinationFile, True)
                        WriteVersionFile()
                    Next
                Else
                    For Each OriginalFile In Directory.GetFiles(ProgramDir & "\Files")
                        DestinationFile = WorkingDir & "\" & OriginalFile.Substring(OriginalFile.LastIndexOf("\"c) + 1)
                        Debug.WriteLine("OriginalFile = " & OriginalFile & "  DestinationFile = " & DestinationFile)
                        If Not File.Exists(DestinationFile) Then File.Copy(OriginalFile, DestinationFile)
                    Next
                End If
            End If
        End If
        LoadSettings()
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        SaveSettings()
    End Sub

    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        Me.Close()
    End Sub

#End Region

#Region " Functional Subs "

    Private Sub DecoderCalBrowse()
        Dim FilterFile As String
        Dim Value As Double

        Try
            With OpenFileDialog1
                If File.Exists(DecoderCalFileTextBox1.Text) Then
                    .FileName = DecoderCalFileTextBox1.Text
                Else
                    .InitialDirectory = WorkingDir
                End If
                .Title = "Load Decoder Calibration"
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog() = DialogResult.OK Then
                    Value = LoadCalFile(.FileName, "decoder", FilterFile)
                    If Value < NaN Then
                        DecoderCalValue = Value
                        DecoderCalFileTextBox1.Text = .FileName
                        DecoderCalFileTextBox2.Text = .FileName
                        DecoderCalFileTextBox3.Text = .FileName
                        DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                        DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                        DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                    End If
                    'MobileLoopSetupLoadButton.Enabled = Not (EncoderCalValue = NaN Or DecoderCalValue = NaN)
                End If
            End With
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Decoder calibration could not be loaded.", "Browse Decoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub EncoderCalBrowse()
        Dim FilterFile As String
        Dim Value As Double

        Try
            With OpenFileDialog1
                If File.Exists(EncoderCalFileTextBox1.Text) Then
                    .FileName = EncoderCalFileTextBox1.Text
                Else
                    .InitialDirectory = WorkingDir
                End If
                .Title = "Load Encoder Calibration"
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog() = DialogResult.OK Then
                    Value = LoadCalFile(.FileName, "encoder", FilterFile)
                    If Value < NaN Then
                        EncoderCalValue = Value
                        EncoderCalFileTextBox1.Text = .FileName
                        EncoderCalFileTextBox2.Text = .FileName
                        EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                        EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                        'MobileLoopSetupLoadButton.Enabled = Not (EncoderCalValue = NaN Or DecoderCalValue = NaN)
                    End If
                End If
            End With
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Encoder calibration could not be loaded.", "Browse Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub MobileInCalBrowse()
        Dim FilterFile As String
        Dim Value As Double

        Try
            With OpenFileDialog1
                If File.Exists(MobileInCalFileTextBox1.Text) Then
                    .FileName = MobileInCalFileTextBox1.Text
                Else
                    .InitialDirectory = WorkingDir
                End If
                .Title = "Load Mobile Input Calibration"
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog() = DialogResult.OK Then
                    Value = LoadCalFile(.FileName, "mobile_in", FilterFile)
                    If Value < NaN Then
                        MobileInCalValue = Value
                        MobileInCalFileTextBox1.Text = .FileName
                        MobileInCalFileTextBox2.Text = .FileName
                        MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                        MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                        MobileInCalFilter = FilterFile
                        'MobileLoopSetupLoadButton.Enabled = Not (EncoderCalValue = NaN Or DecoderCalValue = NaN)
                    End If
                End If
            End With
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Mobile input calibration could not be loaded.", "Browse Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub MobileOutCalBrowse()
        Dim FilterFile As String
        Dim Value As Double

        Try
            With OpenFileDialog1
                If File.Exists(MobileOutCalFileTextBox1.Text) Then
                    .FileName = MobileOutCalFileTextBox1.Text
                Else
                    .InitialDirectory = WorkingDir
                End If
                .Title = "Load Mobile Output Calibration"
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog() = DialogResult.OK Then
                    Value = LoadCalFile(.FileName, "mobile_out", FilterFile)
                    If Value < NaN Then
                        MobileOutCalValue = Value
                        MobileOutCalFileTextBox1.Text = .FileName
                        MobileOutCalFileTextBox2.Text = .FileName
                        MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                        MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                        MobileOutCalFilter = FilterFile
                        'MobileLoopSetupLoadButton.Enabled = Not (EncoderCalValue = NaN Or DecoderCalValue = NaN)
                    End If
                End If
            End With
        Catch ex As Exception
            Debug.WriteLine(ex.ToString)
            MessageBox.Show("Mobile output calibration could not be loaded.", "Browse Mobile Output Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub ClearWavFileTextBoxes()
        WavFileTextBox1.Text = ""
        WavFileTextBox2.Text = ""
        WavFileTextBox3.Text = ""
        WavFileTextBox4.Text = ""
    End Sub

    Private Sub WavFileBrowse()
        With OpenFileDialog1
            .Title = "Load Test Signal wav File"
            If File.Exists(WavFileTextBox1.Text) Then
                .FileName = WavFileTextBox1.Text
            Else
                .InitialDirectory = WorkingDir
            End If
            .Filter = "Wave Files (*.wav)|*.wav"
            If .ShowDialog() = DialogResult.OK Then
                WavFileTextBox1.Text = .FileName
                WavFileTextBox2.Text = .FileName
                WavFileTextBox3.Text = .FileName
                WavFileTextBox4.Text = .FileName
            End If
        End With
    End Sub

    Private Sub DecoderCalibration()
        Dim CalResult As Double
        MessageBox.Show("Set CMU speech codec to 'Decoder Cal.'", "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.DecoderCal(WorkingDir & "\DecoderCal.SET")
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult < 3.0E+38 Then
            DecoderCalValue = CalResult
            MessageBox.Show("FS peak decoder output voltage = " & (1000 * DecoderCalValue).ToString("#.## mV"), "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            With SaveFileDialog1
                .Title = "Save Decoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, DecoderCalValue, "decoder")
                    DecoderCalFileTextBox1.Text = .FileName
                    DecoderCalFileTextBox2.Text = .FileName
                    DecoderCalFileTextBox3.Text = .FileName
                Else
                    DecoderCalFileTextBox1.Text = ""
                    DecoderCalFileTextBox2.Text = ""
                    DecoderCalFileTextBox3.Text = ""
                End If
            End With
        End If
    End Sub

    Private Sub EncoderCalibration()
        Dim CalResult As Double

        If DecoderCalValue < NaN Then
            MessageBox.Show("Set CMU speech codec to 'Encoder Cal.'", "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Calib.ResetUPVErrorInfo()
            CalResult = Calib.EncoderCal(WorkingDir & "\DecoderCal.SET", DecoderCalValue)
            If Calib.UPVError Then
                MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            If CalResult < 3.0E+38 Then
                EncoderCalValue = CalResult
                MessageBox.Show("FS peak encoder input voltage = " & (1000 * EncoderCalValue).ToString("#.## mV"), "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
                With SaveFileDialog1
                    .Title = "Save Encoder Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, EncoderCalValue, "encoder")
                        EncoderCalFileTextBox1.Text = .FileName
                        EncoderCalFileTextBox2.Text = .FileName
                    Else
                        EncoderCalFileTextBox1.Text = ""
                        EncoderCalFileTextBox2.Text = ""
                    End If
                End With
            End If
            MessageBox.Show("GSM: Set 'Bit Stream' to 'Speechcod./Handset Low'!" & ControlChars.CrLf & "UMTS: Set 'Voice Settings' to 'Speechcodec Low'!" & ControlChars.CrLf & "cdma2000: Set 'Voice Coder' to '8k Enhanced (Low)' or '8k EVRC (Low)'!")
        Else
            MessageBox.Show("Decoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration first!", "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub MobileOutputCalibration()
        Dim CalResult As Double

        If DecoderCalValue < NaN Then
            Calib.ResetUPVErrorInfo()
            CalResult = Calib.MobileOutputCal(WorkingDir & "\PESQ_Downlink.set", EncoderCalValue)
            If Calib.UPVError Then
                MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            If CalResult < 3.0E+38 Then
                MobileOutCalValue = CalResult
                MessageBox.Show("Maximum peak mobile output voltage = " & (1000 * MobileOutCalValue).ToString("#.## mV"), "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
                With SaveFileDialog1
                    .Title = "Save Mobile Output Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, MobileOutCalValue, "mobile_out")
                        MobileOutCalFileTextBox1.Text = .FileName
                        MobileOutCalFileTextBox2.Text = .FileName
                    Else
                        MobileOutCalFileTextBox1.Text = ""
                        MobileOutCalFileTextBox2.Text = ""
                    End If
                End With
            End If
        Else
            MessageBox.Show("Encoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration first!", "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub MobileInputCalibration()
        Dim InputCalResult As Double
        Dim FilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then FilterFile = GenFiltTextBox.Text
        If DecoderCalValue < NaN Then
            MessageBox.Show("GSM: Set 'Bit Stream' to 'Speechcod./Handset Low'!" & ControlChars.CrLf & "UMTS: Set 'Voice Settings' to 'Speechcodec Low'!" & ControlChars.CrLf & "cdma2000: Set 'Voice Coder' to '8k Enhanced (Low)'!", "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Calib.ResetUPVErrorInfo()
            InputCalResult = Calib.MobileInputCal(WorkingDir & "\UplinkCal.SET", DecoderCalValue, FilterFile)
            If Calib.UPVError Then
                MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            If InputCalResult < 3.0E+38 Then
                MobileInCalValue = InputCalResult
                MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                With SaveFileDialog1
                    .Title = "Save Mobile Input Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, MobileInCalValue, "mobile_in", FilterFile)
                        MobileInCalFileTextBox1.Text = .FileName
                        MobileInCalFileTextBox2.Text = .FileName
                        MobileInCalFilter = FilterFile
                    Else
                        MobileInCalFileTextBox1.Text = ""
                        MobileInCalFileTextBox2.Text = ""
                        MobileInCalFilter = String.Empty
                    End If
                End With
            End If
        Else
            MessageBox.Show("Decoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration first!", "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub LoadUplinkSetup()
        Dim IsOk As Boolean = True
        Dim FilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then FilterFile = GenFiltTextBox.Text
        If FilterFile = MobileInCalFilter Then          'Calibration was done with the same filter as currently selected
            If Not MobileInCalValue < NaN Then
                MessageBox.Show("Mobile input calibration value missing." & ControlChars.CrLf & " Perform mobile input calibration or uplink in/out calibration first" & ControlChars.CrLf & "or load mobile input calibration value!", "Load Setup for Uplink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If Not DecoderCalValue < NaN Then
                MessageBox.Show("Decoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or uplink in/out calibration first" & ControlChars.CrLf & "or load decoder calibration value!", "Load Setup for Uplink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If IsOk Then
                If File.Exists(UplinkSetupTextBox.Text) Then
                    Calib.ResetUPVErrorInfo()
                    Calib.LoadSetup(1, 2, MobileInCalValue, DecoderCalValue, UplinkSetupTextBox.Text, WavFileTextBox1.Text, dBFSUpDown1.Value, FilterFile, String.Empty, FSCheckBox1.Checked)
                    If Calib.UPVError Then
                        MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Exit Sub
                    End If
                    If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                    If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
                Else
                    MessageBox.Show("Specified setup file does not exist." & ControlChars.CrLf & "Open existing setup file and re-try!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Else
            MessageBox.Show("Calibration was done with different filter setting." & ControlChars.CrLf & "Load matching mobile input calibration file " & ControlChars.CrLf & "or perform mobile input (speech) calibration first!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub BrowseUplinkSetup()
        Dim IsOk As Boolean = True
        Dim FilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then FilterFile = GenFiltTextBox.Text
        If FilterFile = MobileInCalFilter Then          'Calibration was done with the same filter as currently selected
            If Not MobileInCalValue < NaN Then
                MessageBox.Show("Mobile input calibration value missing." & ControlChars.CrLf & " Perform mobile input calibration or uplink in/out calibration first" & ControlChars.CrLf & "or load mobile input calibration value!", "Load Setup for Uplink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If Not DecoderCalValue < NaN Then
                MessageBox.Show("Decoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or uplink in/out calibration first" & ControlChars.CrLf & "or load decoder calibration value!", "Load Setup for Uplink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If IsOk Then
                With OpenFileDialog1
                    If (Not UplinkSetupTextBox.Text = String.Empty) And File.Exists(UplinkSetupTextBox.Text) Then
                        .FileName = UplinkSetupTextBox.Text
                    Else
                        .InitialDirectory = WorkingDir
                    End If
                    .Filter = "UPV Setup Files (*.set)|*.set"
                    If .ShowDialog() = DialogResult.OK Then
                        UplinkSetupTextBox.Text = .FileName
                        Application.DoEvents()
                        Calib.ResetUPVErrorInfo()
                        Calib.LoadSetup(1, 2, MobileInCalValue, DecoderCalValue, UplinkSetupTextBox.Text, WavFileTextBox1.Text, dBFSUpDown1.Value, FilterFile, String.Empty, FSCheckBox1.Checked)
                        If Calib.UPVError Then
                            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            Exit Sub
                        End If
                        If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                        If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
                    End If
                End With
            End If
        Else
            MessageBox.Show("Calibration was done with different filter setting." & ControlChars.CrLf & "Load matching mobile input calibration file " & ControlChars.CrLf & "or perform mobile input (speech) calibration first!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub LoadDownlinkSetup()
        Dim IsOk As Boolean = True
        Dim FilterFile As String = String.Empty

        If AnFiltCheckBox1.Checked Then FilterFile = AnFiltTextBox1.Text
        If Not EncoderCalValue < NaN Then
            MessageBox.Show("Encoder calibration value missing." & ControlChars.CrLf & " Perform encoder calibration or downlink in/out calibration first" & ControlChars.CrLf & "or load encoder calibration value!", "Load Setup for Downlink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If Not MobileOutCalValue < NaN Then
            MessageBox.Show("Mobile output calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or downlink in/out calibration first" & ControlChars.CrLf & "or load mobile output calibration value!", "Load Setup for Downlink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If IsOk Then
            If File.Exists(DownlinkSetupTextBox.Text) Then
                Calib.ResetUPVErrorInfo()
                Calib.LoadSetup(2, 1, EncoderCalValue, MobileOutCalValue, DownlinkSetupTextBox.Text, WavFileTextBox2.Text, dBFSUpDown2.Value, String.Empty, FilterFile, FSCheckBox1.Checked)
                If Calib.UPVError Then
                    MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End If
                If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
            Else
                MessageBox.Show("Specified setup file does not exist." & ControlChars.CrLf & "Open existing setup file and re-try!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub BrowseDownlinkSetup()
        Dim IsOk As Boolean = True
        Dim FilterFile As String = String.Empty

        If AnFiltCheckBox1.Checked Then FilterFile = AnFiltTextBox1.Text
        If Not EncoderCalValue < NaN Then
            MessageBox.Show("Encoder calibration value missing." & ControlChars.CrLf & " Perform encoder calibration or downlink in/out calibration first" & ControlChars.CrLf & "or load encoder calibration value!", "Load Setup for Downlink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If Not MobileOutCalValue < NaN Then
            MessageBox.Show("Mobile output calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or downlink in/out calibration first" & ControlChars.CrLf & "or load mobile output calibration value!", "Load Setup for Downlink", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If IsOk Then
            With OpenFileDialog1
                If (Not DownlinkSetupTextBox.Text = String.Empty) And File.Exists(DownlinkSetupTextBox.Text) Then
                    .FileName = DownlinkSetupTextBox.Text
                Else
                    .InitialDirectory = WorkingDir
                End If
                .Filter = "UPV Setup Files (*.set)|*.set"
                If .ShowDialog() = DialogResult.OK Then
                    DownlinkSetupTextBox.Text = .FileName
                    Application.DoEvents()
                    Calib.ResetUPVErrorInfo()
                    Calib.LoadSetup(2, 1, EncoderCalValue, MobileOutCalValue, DownlinkSetupTextBox.Text, WavFileTextBox2.Text, dBFSUpDown2.Value, String.Empty, FilterFile, FSCheckBox1.Checked)
                    If Calib.UPVError Then
                        MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Exit Sub
                    End If
                    If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                    If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
                End If
            End With
        End If
    End Sub

    Private Sub LoadNetworkLoopSetup()
        Dim IsOk As Boolean = True
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
        If AnFiltCheckBox1.Checked Then AnFilterFile = AnFiltTextBox1.Text
        If GenFilterFile = MobileInCalFilter Then          'Calibration was done with the same filter as currently selected

            If Not MobileInCalValue < NaN Then
                MessageBox.Show("Mobile input calibration value missing." & ControlChars.CrLf & " Perform mobile input calibration or network loop in/out calibration first" & ControlChars.CrLf & "or load mobile input calibration value!", "Load Setup for Network Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If Not MobileOutCalValue < NaN Then
                MessageBox.Show("Mobile output calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or network loop in/out calibration first" & ControlChars.CrLf & "or load mobile output calibration value!", "Load Setup for Network Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If IsOk Then
                If File.Exists(NetworkLoopSetupTextBox.Text) Then
                    Calib.ResetUPVErrorInfo()
                    Calib.LoadSetup(1, 1, MobileInCalValue, MobileOutCalValue, NetworkLoopSetupTextBox.Text, WavFileTextBox3.Text, dBFSUpDown3.Value, GenFilterFile, AnFilterFile, FSCheckBox1.Checked)
                    If Calib.UPVError Then
                        MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Exit Sub
                    End If
                    If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                    If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
                Else
                    MessageBox.Show("Specified setup file does not exist." & ControlChars.CrLf & "Open existing setup file and re-try!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If
            End If
        Else
            MessageBox.Show("Calibration was done with different filter setting." & ControlChars.CrLf & "Load matching mobile input calibration file " & ControlChars.CrLf & "or perform mobile input (speech) calibration first!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub BrowseNetworkLoopSetup()
        Dim IsOk As Boolean = True
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
        If AnFiltCheckBox1.Checked Then AnFilterFile = AnFiltTextBox1.Text
        If GenFilterFile = MobileInCalFilter Then          'Calibration was done with the same filter as currently selected
            If Not MobileInCalValue < NaN Then
                MessageBox.Show("Mobile input calibration value missing." & ControlChars.CrLf & " Perform mobile input calibration or network loop in/out calibration first" & ControlChars.CrLf & "or load mobile input calibration value!", "Load Setup for Network Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If Not MobileOutCalValue < NaN Then
                MessageBox.Show("Mobile output calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or network loop in/out calibration first" & ControlChars.CrLf & "or load mobile output calibration value!", "Load Setup for Network Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                IsOk = False
            End If
            If IsOk Then
                With OpenFileDialog1
                    If (Not NetworkLoopSetupTextBox.Text = String.Empty) And File.Exists(NetworkLoopSetupTextBox.Text) Then
                        .FileName = NetworkLoopSetupTextBox.Text
                    Else
                        .InitialDirectory = WorkingDir
                    End If
                    .Filter = "UPV Setup Files (*.set)|*.set"
                    If .ShowDialog() = DialogResult.OK Then
                        NetworkLoopSetupTextBox.Text = .FileName
                        Application.DoEvents()
                        Calib.ResetUPVErrorInfo()
                        Calib.LoadSetup(1, 1, MobileInCalValue, MobileOutCalValue, NetworkLoopSetupTextBox.Text, WavFileTextBox3.Text, dBFSUpDown3.Value, GenFilterFile, AnFilterFile, FSCheckBox1.Checked)
                        If Calib.UPVError Then
                            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            Exit Sub
                        End If
                        If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                        If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
                    End If
                End With
            End If
        Else
            MessageBox.Show("Calibration was done with different filter setting." & ControlChars.CrLf & "Load matching mobile input calibration file " & ControlChars.CrLf & "or perform mobile input (speech) calibration first!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub LoadMobileLoopSetup()
        Dim IsOk As Boolean = True

        If Not EncoderCalValue < NaN Then
            MessageBox.Show("Encoder calibration value missing." & ControlChars.CrLf & " Perform encoder calibration or mobile loop in/out calibration first" & ControlChars.CrLf & "or load encoder calibration value!", "Load Setup for Mobile Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If Not DecoderCalValue < NaN Then
            MessageBox.Show("Decoder calibration value missing." & ControlChars.CrLf & " Perform decoder calibration or mobile loop in/out calibration first" & ControlChars.CrLf & "or load decoder calibration value!", "Load Setup for Mobile Loop", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            IsOk = False
        End If
        If IsOk Then
            If File.Exists(MobileLoopSetupTextBox.Text) Then
                Calib.ResetUPVErrorInfo()
                Calib.LoadSetup(2, 2, EncoderCalValue, DecoderCalValue, MobileLoopSetupTextBox.Text, WavFileTextBox4.Text, dBFSUpDown4.Value, String.Empty, String.Empty, FSCheckBox1.Checked)
                If Calib.UPVError Then
                    MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End If
                If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
            Else
                MessageBox.Show("Specified setup file does not exist." & ControlChars.CrLf & "Open existing setup file and re-try!", "Load Setup", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub BrowseMobileLoopSetup()
        With OpenFileDialog1
            If (Not MobileLoopSetupTextBox.Text = String.Empty) And File.Exists(MobileLoopSetupTextBox.Text) Then
                .FileName = MobileLoopSetupTextBox.Text
            Else
                .InitialDirectory = WorkingDir
            End If
            .Filter = "UPV Setup Files (*.set)|*.set"
            If .ShowDialog() = DialogResult.OK Then
                MobileLoopSetupTextBox.Text = .FileName
                Application.DoEvents()
                Calib.ResetUPVErrorInfo()
                Calib.LoadSetup(2, 2, EncoderCalValue, DecoderCalValue, MobileLoopSetupTextBox.Text, WavFileTextBox4.Text, dBFSUpDown4.Value, String.Empty, String.Empty, FSCheckBox1.Checked)
                If Calib.UPVError Then
                    MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End If
                If StartCheckBox.Checked Then Calib.StartSingleMeasurement()
                If MinimizeCheckBox.Checked Then Me.WindowState = FormWindowState.Minimized
            End If
        End With
    End Sub

    Private Sub UplinkIOCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If MessageBox.Show("Do not use this function with coupling via loudspeaker or artificial mouth!" & ControlChars.CrLf & "The speaker may be damaged by overload!" & ControlChars.CrLf & "Click 'Ok' to continue or 'Cancel' to abort!", "Warning", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) = DialogResult.OK Then
            If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
            MessageBox.Show("Set CMU speech codec to 'Handset Low'!", "Uplink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Calib.ResetUPVErrorInfo()
            CalResult = Calib.InOutCal(WorkingDir & "\LoopCal.SET", 1, 2, GenFilterFile, AnFilterFile)
            If Calib.UPVError Then
                MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            If CalResult.AValue < NaN And CalResult.BValue < NaN Then
                MobileInCalValue = CalResult.AValue
                MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                DecoderCalValue = CalResult.BValue
                MessageBox.Show("FS peak decoder output voltage = " & (1000 * DecoderCalValue).ToString("#.## mV"), "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                Application.DoEvents()
                With SaveFileDialog1
                    .Title = "Save Mobile Input Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, MobileInCalValue, "mobile_in", GenFilterFile)
                        MobileInCalFileTextBox1.Text = .FileName
                        MobileInCalFileTextBox2.Text = .FileName
                    Else
                        MobileInCalFileTextBox1.Text = ""
                        MobileInCalFileTextBox2.Text = ""
                    End If
                End With
                With SaveFileDialog1
                    .Title = "Save Decoder Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, DecoderCalValue, "decoder")
                        DecoderCalFileTextBox1.Text = .FileName
                        DecoderCalFileTextBox2.Text = .FileName
                        DecoderCalFileTextBox3.Text = .FileName
                    Else
                        DecoderCalFileTextBox1.Text = ""
                        DecoderCalFileTextBox2.Text = ""
                        DecoderCalFileTextBox3.Text = ""
                    End If
                End With
                With SaveFileDialog1
                    .Title = "Save In/Out-Curve"
                    .InitialDirectory = WorkingDir
                    .Filter = "Comma Separated Files (*.csv)|*.csv"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCurve(.FileName, Calib.IOCurveXValues, Calib.IOCurveYValues)
                    End If
                End With
            Else
                MessageBox.Show("Calibration not successful.", "Uplink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub UplinkIOSpeechCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If MessageBox.Show("Do not use this function with coupling via loudspeaker or artificial mouth!" & ControlChars.CrLf & "The speaker may be damaged by overload!" & ControlChars.CrLf & "Click 'Ok' to continue or 'Cancel' to abort!", "Warning", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) = DialogResult.OK Then
            If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
            MessageBox.Show("Set CMU speech codec to 'Handset Low'!", "Uplink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Calib.ResetUPVErrorInfo()
            CalResult = Calib.InOutSpeechCal(WorkingDir & "\LoopCal.SET", 1, 2, GenFilterFile, AnFilterFile)
            If Calib.UPVError Then
                MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            If CalResult.AValue < NaN And CalResult.BValue < NaN Then
                MobileInCalValue = CalResult.AValue
                MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                DecoderCalValue = CalResult.BValue
                MessageBox.Show("FS peak decoder output voltage = " & (1000 * DecoderCalValue).ToString("#.## mV"), "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
                Application.DoEvents()
                With SaveFileDialog1
                    .Title = "Save Mobile Input Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, MobileInCalValue, "mobile_in", GenFilterFile)
                        MobileInCalFileTextBox1.Text = .FileName
                        MobileInCalFileTextBox2.Text = .FileName
                    Else
                        MobileInCalFileTextBox1.Text = ""
                        MobileInCalFileTextBox2.Text = ""
                    End If
                End With
                With SaveFileDialog1
                    .Title = "Save Decoder Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, DecoderCalValue, "decoder")
                        DecoderCalFileTextBox1.Text = .FileName
                        DecoderCalFileTextBox2.Text = .FileName
                        DecoderCalFileTextBox3.Text = .FileName
                    Else
                        DecoderCalFileTextBox1.Text = ""
                        DecoderCalFileTextBox2.Text = ""
                        DecoderCalFileTextBox3.Text = ""
                    End If
                End With
                With SaveFileDialog1
                    .Title = "Save In/Out-Curve"
                    .InitialDirectory = WorkingDir
                    .Filter = "Comma Separated Files (*.csv)|*.csv"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCurve(.FileName, Calib.IOCurveXValues, Calib.IOCurveYValues)
                    End If
                End With
            Else
                MessageBox.Show("Calibration not successful.", "Uplink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End If
    End Sub

    Private Sub DownlinkIOCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim FilterFile As String = String.Empty

        If AnFiltCheckBox1.Checked Then FilterFile = AnFiltTextBox1.Text
        MessageBox.Show("Set CMU speech codec to 'Handset Low'!", "Downlink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutCal(WorkingDir & "\LoopCal.SET", 2, 1, String.Empty, FilterFile)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            EncoderCalValue = CalResult.AValue
            MessageBox.Show("FS peak encoder input voltage = " & (1000 * EncoderCalValue).ToString("#.## mV"), "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            MobileOutCalValue = CalResult.BValue
            MessageBox.Show("Maximum peak mobile output voltage = " & (1000 * MobileOutCalValue).ToString("#.## mV"), "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Encoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, EncoderCalValue, "encoder")
                    EncoderCalFileTextBox1.Text = .FileName
                    EncoderCalFileTextBox2.Text = .FileName
                Else
                    EncoderCalFileTextBox1.Text = ""
                    EncoderCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Mobile Output Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileOutCalValue, "mobile_out")
                    MobileOutCalFileTextBox1.Text = .FileName
                    MobileOutCalFileTextBox2.Text = .FileName
                Else
                    MobileOutCalFileTextBox1.Text = ""
                    MobileOutCalFileTextBox2.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Downlink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub DownlinkIOSpeechCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim FilterFile As String = String.Empty

        If AnFiltCheckBox1.Checked Then FilterFile = AnFiltTextBox1.Text
        MessageBox.Show("Set CMU speech codec to 'Handset Low'!", "Downlink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutSpeechCal(WorkingDir & "\LoopCal.SET", 2, 1, String.Empty, FilterFile)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            EncoderCalValue = CalResult.AValue
            MessageBox.Show("FS peak encoder input voltage = " & (1000 * EncoderCalValue).ToString("#.## mV"), "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            MobileOutCalValue = CalResult.BValue
            MessageBox.Show("Maximum peak mobile output voltage = " & (1000 * MobileOutCalValue).ToString("#.## mV"), "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Encoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, EncoderCalValue, "encoder")
                    EncoderCalFileTextBox1.Text = .FileName
                    EncoderCalFileTextBox2.Text = .FileName
                Else
                    EncoderCalFileTextBox1.Text = ""
                    EncoderCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Mobile Output Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileOutCalValue, "mobile_out")
                    MobileOutCalFileTextBox1.Text = .FileName
                    MobileOutCalFileTextBox2.Text = .FileName
                Else
                    MobileOutCalFileTextBox1.Text = ""
                    MobileOutCalFileTextBox2.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Downlink In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub NetworkLoopIOCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
        If AnFiltCheckBox1.Checked Then AnFilterFile = AnFiltTextBox1.Text
        MessageBox.Show("Set CMU speech codec to 'Loopback'!", "Network Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutCal(WorkingDir & "\LoopCal.SET", 1, 1, GenFilterFile, AnFilterFile)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            MobileInCalValue = CalResult.AValue
            MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
            MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
            MobileOutCalValue = CalResult.BValue
            MessageBox.Show("Maximum peak mobile output voltage = " & (1000 * MobileOutCalValue).ToString("#.## mV"), "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Mobile Input Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileInCalValue, "mobile_in")
                    MobileInCalFileTextBox1.Text = .FileName
                    MobileInCalFileTextBox2.Text = .FileName
                Else
                    MobileInCalFileTextBox1.Text = ""
                    MobileInCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Mobile Output Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileOutCalValue, "mobile_out")
                    MobileOutCalFileTextBox1.Text = .FileName
                    MobileOutCalFileTextBox2.Text = .FileName
                Else
                    MobileOutCalFileTextBox1.Text = ""
                    MobileOutCalFileTextBox2.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Network Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub NetworkLoopIOSpeechCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair
        Dim GenFilterFile As String = String.Empty
        Dim AnFilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then GenFilterFile = GenFiltTextBox.Text
        If AnFiltCheckBox1.Checked Then AnFilterFile = AnFiltTextBox1.Text
        MessageBox.Show("Set CMU speech codec to 'Loopback'!", "Network Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutSpeechCal(WorkingDir & "\LoopCal.SET", 1, 1, GenFilterFile, AnFilterFile)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            MobileInCalValue = CalResult.AValue
            MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
            MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
            MobileOutCalValue = CalResult.BValue
            MessageBox.Show("Maximum peak mobile output voltage = " & (1000 * MobileOutCalValue).ToString("#.## mV"), "Encoder Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MobileOutCalValueTextBox1.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            MobileOutCalValueTextBox2.Text = (1000 * MobileOutCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Mobile Input Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileInCalValue, "mobile_in")
                    MobileInCalFileTextBox1.Text = .FileName
                    MobileInCalFileTextBox2.Text = .FileName
                Else
                    MobileInCalFileTextBox1.Text = ""
                    MobileInCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Mobile Output Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, MobileOutCalValue, "mobile_out")
                    MobileOutCalFileTextBox1.Text = .FileName
                    MobileOutCalFileTextBox2.Text = .FileName
                Else
                    MobileOutCalFileTextBox1.Text = ""
                    MobileOutCalFileTextBox2.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Network Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub MobileLoopIOCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair

        MessageBox.Show("Set CMU speech codec to 'Codec Cal.'!", "Mobile Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutCal(WorkingDir & "\LoopCal.SET", 2, 2, String.Empty, String.Empty)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            EncoderCalValue = CalResult.AValue
            MessageBox.Show("FS peak encoder input voltage = " & (1000 * EncoderCalValue).ToString("#.## mV"), "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            DecoderCalValue = CalResult.BValue
            MessageBox.Show("FS peak decoder output voltage = " & (1000 * DecoderCalValue).ToString("#.## mV"), "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Encoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, EncoderCalValue, "encoder")
                    EncoderCalFileTextBox1.Text = .FileName
                    EncoderCalFileTextBox2.Text = .FileName
                Else
                    EncoderCalFileTextBox1.Text = ""
                    EncoderCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Decoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, DecoderCalValue, "decoder")
                    DecoderCalFileTextBox1.Text = .FileName
                    DecoderCalFileTextBox2.Text = .FileName
                    DecoderCalFileTextBox3.Text = .FileName
                Else
                    DecoderCalFileTextBox1.Text = ""
                    DecoderCalFileTextBox2.Text = ""
                    DecoderCalFileTextBox3.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Mobile Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub MobileLoopIOSpeechCalibration()
        Dim CalResult As CMUCalFunctions.ValuePair

        MessageBox.Show("Set CMU speech codec to 'Codec Cal.'!", "Mobile Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Calib.ResetUPVErrorInfo()
        CalResult = Calib.InOutSpeechCal(WorkingDir & "\LoopCal.SET", 2, 2, String.Empty, String.Empty)
        If Calib.UPVError Then
            MessageBox.Show(Calib.UPVErrorMessage, "UPV Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If CalResult.AValue < NaN And CalResult.BValue < NaN Then
            EncoderCalValue = CalResult.AValue
            MessageBox.Show("FS peak encoder input voltage = " & (1000 * EncoderCalValue).ToString("#.## mV"), "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            EncoderCalValueTextBox1.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            EncoderCalValueTextBox2.Text = (1000 * EncoderCalValue).ToString("#.## mV")
            DecoderCalValue = CalResult.BValue
            MessageBox.Show("FS peak decoder output voltage = " & (1000 * DecoderCalValue).ToString("#.## mV"), "DecoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            DecoderCalValueTextBox1.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox2.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            DecoderCalValueTextBox3.Text = (1000 * DecoderCalValue).ToString("#.## mV")
            Application.DoEvents()
            With SaveFileDialog1
                .Title = "Save Encoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, EncoderCalValue, "encoder")
                    EncoderCalFileTextBox1.Text = .FileName
                    EncoderCalFileTextBox2.Text = .FileName
                Else
                    EncoderCalFileTextBox1.Text = ""
                    EncoderCalFileTextBox2.Text = ""
                End If
            End With
            With SaveFileDialog1
                .Title = "Save Decoder Calibration"
                .InitialDirectory = WorkingDir
                .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                If .ShowDialog = DialogResult.OK Then
                    StoreCalFile(.FileName, DecoderCalValue, "decoder")
                    DecoderCalFileTextBox1.Text = .FileName
                    DecoderCalFileTextBox2.Text = .FileName
                    DecoderCalFileTextBox3.Text = .FileName
                Else
                    DecoderCalFileTextBox1.Text = ""
                    DecoderCalFileTextBox2.Text = ""
                    DecoderCalFileTextBox3.Text = ""
                End If
            End With
        Else
            MessageBox.Show("Calibration not successful.", "Mobile Loop In/Out Calibration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub ShowInstructions(ByVal CaptionText As String, ByVal TextFileName As String)
        Dim InstructionText As String

        Try
            If File.Exists(TextFileName) Then
                FileOpen(4, TextFileName, OpenMode.Input)
                InstructionText = LineInput(4)
                Do While Not EOF(4)
                    InstructionText &= ControlChars.CrLf & LineInput(4)
                Loop
                FileClose(4)
            End If
            MessageBox.Show(InstructionText, CaptionText, MessageBoxButtons.OK)
        Catch ex As Exception

        End Try
    End Sub

    Private Sub MISpeechCalibration()
        Dim SignalRMS As Double
        Dim FileName As String
        Dim InputCalResult As Double
        Dim FilterFile As String = String.Empty

        If GenFiltCheckBox.Checked Then FilterFile = GenFiltTextBox.Text
        If DecoderCalValue < NaN Then
            MessageBox.Show("GSM: Set 'Bit Stream' to 'Speechcod./Handset Low'!" & ControlChars.CrLf & "UMTS: Set 'Voice Settings' to 'Speechcodec Low'!" & ControlChars.CrLf & "cdma2000: Set 'Voice Coder' to '8k Enhanced (Low)'!", "EncoderCalibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
            InputCalResult = Calib.MobileInputSpeechCal(WorkingDir & "\PESQ_Uplink.SET", DecoderCalValue, FilterFile, RadioButton26.Checked)
            If InputCalResult < 3.0E+38 Then
                MobileInCalValue = InputCalResult
                MessageBox.Show("FS peak mobile input voltage = " & (1000 * MobileInCalValue).ToString("#.## mV"), "Mobile Input Calibration", MessageBoxButtons.OK, MessageBoxIcon.Information)
                MobileInCalValueTextBox1.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                MobileInCalValueTextBox2.Text = (1000 * MobileInCalValue).ToString("#.## mV")
                With SaveFileDialog1
                    .Title = "Save Mobile Input Calibration"
                    .InitialDirectory = WorkingDir
                    .Filter = "UPV Calibration Files (*.ccl)|*.ccl"
                    If .ShowDialog = DialogResult.OK Then
                        StoreCalFile(.FileName, MobileInCalValue, "mobile_in", FilterFile)
                        MobileInCalFileTextBox1.Text = .FileName
                        MobileInCalFileTextBox2.Text = .FileName
                        MobileInCalFilter = FilterFile
                    Else
                        MobileInCalFileTextBox1.Text = ""
                        MobileInCalFileTextBox2.Text = ""
                        MobileInCalFilter = String.Empty
                    End If
                End With
            End If
        End If
    End Sub

    Private Sub GenFiltBrowse()
        With OpenFileDialog1
            If File.Exists(GenFiltTextBox.Text) Then
                .FileName = GenFiltTextBox.Text
            Else
                .InitialDirectory = WorkingDir
            End If
            .Filter = "UPV Filter Files (*.npz;*.xpz;*.coe)|*.npz;*.xpz;*.coe"
            If .ShowDialog() = DialogResult.OK Then
                GenFiltTextBox.Text = .FileName
                GenFiltTextBox1.Text = .FileName
                Application.DoEvents()
            End If
        End With
        If GenFiltTextBox.Text = String.Empty Then
            GenFiltCheckBox.Checked = False
            GenFiltCheckBox1.Checked = False
        End If
    End Sub

    Private Sub AnFiltBrowse()
        With OpenFileDialog1
            If File.Exists(AnFiltTextBox1.Text) Then
                .FileName = AnFiltTextBox1.Text
            Else
                .InitialDirectory = WorkingDir
            End If
            .Filter = "UPV Filter Files (*.npz;*.xpz;*.coe)|*.npz;*.xpz;*.coe"
            If .ShowDialog() = DialogResult.OK Then
                AnFiltTextBox1.Text = .FileName
                AnFiltTextBox2.Text = .FileName
                Application.DoEvents()
            End If
        End With
        If AnFiltTextBox1.Text = String.Empty Then
            AnFiltCheckBox1.Checked = False
            AnFiltCheckBox2.Checked = False
        End If
    End Sub

#End Region

#Region " User Interface "

    Private Sub DecoderCalBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalBrowseButton1.Click
        DecoderCalBrowse()
    End Sub

    Private Sub DecoderCalBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalBrowseButton2.Click
        DecoderCalBrowse()
    End Sub

    Private Sub EncoderCalBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EncoderCalBrowseButton1.Click
        EncoderCalBrowse()
    End Sub

    Private Sub EncoderCalBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EncoderCalBrowseButton2.Click
        DecoderCalBrowse()
    End Sub

    Private Sub MobileInCalBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileInCalBrowseButton1.Click
        MobileInCalBrowse()
    End Sub

    Private Sub MobileInCalBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileInCalBrowseButton2.Click
        MobileInCalBrowse()
    End Sub

    Private Sub MobileOutCalBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileOutCalBrowseButton1.Click
        MobileOutCalBrowse()
    End Sub

    Private Sub MobileOutCalBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileOutCalBrowseButton2.Click
        MobileOutCalBrowse()
    End Sub

    Private Sub DecoderCalBrowseButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalBrowseButton3.Click
        EncoderCalBrowse()
    End Sub

    Private Sub ShowSchematic(ByVal CaptionText As String, ByVal PictureFileName As String)
        Dim Viewer As New PictureViewer(CaptionText, PictureFileName)
        Viewer.Show()
    End Sub

    Private Sub ShowUplinkSchematicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowUplinkSchematicButton.Click
        ShowSchematic("Uplink Measurement", ProgramDir & "\uplink.gif")
    End Sub

    Private Sub ShowUplinkInstructionsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowUplinkInstructionsButton.Click
        ShowInstructions("Uplink Measurement", ProgramDir & "\uplink.txt")
    End Sub

    Private Sub ShowDownlinkSchematicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowDownlinkSchematicButton.Click
        ShowSchematic("Downlink Measurement", ProgramDir & "\downlink.gif")
    End Sub

    Private Sub ShowDownlinkInstructionsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowDownlinkInstructionsButton.Click
        ShowInstructions("Downlink Measurement", ProgramDir & "\downlink.txt")
    End Sub

    Private Sub ShowNetworkLoopSchematicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowNetworkLoopSchematicButton.Click
        ShowSchematic("Network Loop Measurement", ProgramDir & "\netloop.gif")
    End Sub

    Private Sub ShowNetworkLoopInstructionsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowNetworkLoopInstructionsButton.Click
        ShowInstructions("Network Loop Measurement", ProgramDir & "\netloop.txt")
    End Sub

    Private Sub ShowMobileLoopSchematicButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowMobileLoopSchematicButton.Click
        ShowSchematic("Mobile Loop Measurement", ProgramDir & "\mobileloop.gif")
    End Sub

    Private Sub ShowMobileLoopInstructionsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowMobileLoopInstructionsButton.Click
        ShowInstructions("Mobile Loop Measurement", ProgramDir & "\mobileloop.txt")
    End Sub

    Private Sub dBFSUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dBFSUpDown1.ValueChanged
        If dBFSUpDown2.Value <> dBFSUpDown1.Value Then dBFSUpDown2.Value = dBFSUpDown1.Value
        If dBFSUpDown3.Value <> dBFSUpDown1.Value Then dBFSUpDown3.Value = dBFSUpDown1.Value
        If dBFSUpDown4.Value <> dBFSUpDown1.Value Then dBFSUpDown4.Value = dBFSUpDown1.Value
    End Sub

    Private Sub dBFSUpDown2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dBFSUpDown2.ValueChanged
        If dBFSUpDown1.Value <> dBFSUpDown2.Value Then dBFSUpDown1.Value = dBFSUpDown2.Value
        If dBFSUpDown3.Value <> dBFSUpDown2.Value Then dBFSUpDown3.Value = dBFSUpDown2.Value
        If dBFSUpDown4.Value <> dBFSUpDown2.Value Then dBFSUpDown4.Value = dBFSUpDown2.Value
    End Sub

    Private Sub dBFSUpDown3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dBFSUpDown3.ValueChanged
        If dBFSUpDown1.Value <> dBFSUpDown3.Value Then dBFSUpDown1.Value = dBFSUpDown3.Value
        If dBFSUpDown2.Value <> dBFSUpDown3.Value Then dBFSUpDown2.Value = dBFSUpDown3.Value
        If dBFSUpDown4.Value <> dBFSUpDown3.Value Then dBFSUpDown4.Value = dBFSUpDown3.Value
    End Sub

    Private Sub dBFSUpDown4_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dBFSUpDown4.ValueChanged
        If dBFSUpDown1.Value <> dBFSUpDown4.Value Then dBFSUpDown1.Value = dBFSUpDown4.Value
        If dBFSUpDown2.Value <> dBFSUpDown4.Value Then dBFSUpDown2.Value = dBFSUpDown4.Value
        If dBFSUpDown3.Value <> dBFSUpDown4.Value Then dBFSUpDown3.Value = dBFSUpDown4.Value
    End Sub

    Private Sub WavFileClearButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileClearButton1.Click
        ClearWavFileTextBoxes()
    End Sub

    Private Sub WavFileClearButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileClearButton2.Click
        ClearWavFileTextBoxes()
    End Sub

    Private Sub WavFileClearButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileClearButton3.Click
        ClearWavFileTextBoxes()
    End Sub

    Private Sub WavFileClearButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileClearButton4.Click
        ClearWavFileTextBoxes()
    End Sub

    Private Sub WavFileBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileBrowseButton1.Click
        WavFileBrowse()
    End Sub

    Private Sub WavFileBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileBrowseButton2.Click
        WavFileBrowse()
    End Sub

    Private Sub WavFileBrowseButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileBrowseButton3.Click
        WavFileBrowse()
    End Sub

    Private Sub WavFileBrowseButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WavFileBrowseButton4.Click
        WavFileBrowse()
    End Sub

    Private Sub DecoderCalButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalButton1.Click
        DecoderCalibration()
    End Sub

    Private Sub DecoderCalButton32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalButton32.Click
        DecoderCalibration()
    End Sub

    Private Sub DecoderCalButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecoderCalButton3.Click
        DecoderCalibration()
    End Sub

    Private Sub EncoderCalButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EncoderCalButton1.Click
        EncoderCalibration()
    End Sub

    Private Sub EncoderCalButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EncoderCalButton2.Click
        EncoderCalibration()
    End Sub

    Private Sub MobileOutCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileOutCalButton.Click
        MobileOutputCalibration()
    End Sub

    Private Sub MobileInCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileInCalButton.Click
        MobileInputCalibration()
    End Sub

    Private Sub UplinkSetupLoadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UplinkSetupLoadButton.Click
        LoadUplinkSetup()
    End Sub

    Private Sub DownlinkSetupLoadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownlinkSetupLoadButton.Click
        LoadDownlinkSetup()
    End Sub

    Private Sub NetworkLoopSetupLoadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NetworkLoopSetupLoadButton.Click
        LoadNetworkLoopSetup()
    End Sub

    Private Sub MobileLoopSetupLoadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileLoopSetupLoadButton.Click
        LoadMobileLoopSetup()
    End Sub

    Private Sub UplinkSetupBrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UplinkSetupBrowseButton.Click
        BrowseUplinkSetup()
    End Sub

    Private Sub DownlinkSetupBrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownlinkSetupBrowseButton.Click
        BrowseDownlinkSetup()
    End Sub

    Private Sub NetworkLoopBrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NetworkLoopBrowseButton.Click
        BrowseNetworkLoopSetup()
    End Sub

    Private Sub MobileLoopBrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileLoopBrowseButton.Click
        BrowseMobileLoopSetup()
    End Sub

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click
        If MessageBox.Show("Do you really want to clear all values?", "Clear All Values", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) = DialogResult.OK Then
            DecoderCalValue = NaN
            EncoderCalValue = NaN
            MobileInCalValue = NaN
            MobileOutCalValue = NaN

            DecoderCalFileTextBox1.Text = ""
            DecoderCalFileTextBox2.Text = ""
            DecoderCalFileTextBox3.Text = ""
            EncoderCalFileTextBox1.Text = ""
            EncoderCalFileTextBox2.Text = ""
            MobileInCalFileTextBox1.Text = ""
            MobileInCalFileTextBox2.Text = ""
            MobileOutCalFileTextBox1.Text = ""
            MobileOutCalFileTextBox2.Text = ""

            DecoderCalValueTextBox1.Text = ""
            DecoderCalValueTextBox2.Text = ""
            DecoderCalValueTextBox3.Text = ""
            EncoderCalValueTextBox1.Text = ""
            EncoderCalValueTextBox2.Text = ""
            MobileInCalValueTextBox1.Text = ""
            MobileInCalValueTextBox2.Text = ""
            MobileOutCalValueTextBox1.Text = ""
            MobileOutCalValueTextBox2.Text = ""

            UplinkSetupTextBox.Text = ""
            DownlinkSetupTextBox.Text = ""
            NetworkLoopSetupTextBox.Text = ""
            MobileLoopSetupTextBox.Text = ""

            WavFileTextBox1.Text = ""
            WavFileTextBox2.Text = ""
            WavFileTextBox3.Text = ""
            WavFileTextBox4.Text = ""

            dBFSUpDown1.Value = 0
            dBFSUpDown2.Value = 0
            dBFSUpDown3.Value = 0
            dBFSUpDown4.Value = 0
        End If
    End Sub

    Private Sub UplinkIOCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UplinkIOCalButton.Click
        UplinkIOCalibration()
    End Sub

    Private Sub DownlinkIOCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownlinkIOCalButton.Click
        DownlinkIOCalibration()
    End Sub

    Private Sub NetworkLoopIOCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NetworkLoopIOCalButton.Click
        NetworkLoopIOCalibration()
    End Sub

    Private Sub MobileLoopIOCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileLoopIOCalButton.Click
        MobileLoopIOCalibration()
    End Sub

    Private Sub MISpeechCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MISpeechCalButton.Click
        MISpeechCalibration()
    End Sub

    Private Sub GenFiltBrowseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltBrowseButton.Click
        GenFiltBrowse()
    End Sub

    Private Sub GenFiltCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltCheckBox.CheckedChanged
        GenFiltCheckBox1.Checked = GenFiltCheckBox.Checked
        If GenFiltCheckBox.Checked Then
            MessageBox.Show("When using a speaker or artificial mouth for feeding the signal to the mobile," & ControlChars.CrLf & "make sure that the power amplifier in use cannot overload the speaker!" & ControlChars.CrLf & "Rohde & Schwarz assumes no liability for any inappropriate external setup.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            If (GenFiltTextBox.Text = String.Empty) Then GenFiltBrowse()
        End If
    End Sub

    Private Sub GenFiltCheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltCheckBox1.CheckedChanged
        GenFiltCheckBox.Checked = GenFiltCheckBox1.Checked
        If GenFiltCheckBox.Checked And (GenFiltTextBox.Text = String.Empty) Then GenFiltBrowse()
    End Sub

    Private Sub GenFiltBrowseButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltBrowseButton1.Click
        GenFiltBrowse()
    End Sub

    Private Sub AnFiltBrowseButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnFiltBrowseButton2.Click
        AnFiltBrowse()
    End Sub

    Private Sub UplinkIOSpeechCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UplinkIOSpeechCalButton.Click
        UplinkIOSpeechCalibration()
    End Sub

    Private Sub DownlinkIOSpeechCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownlinkIOSpeechCalButton.Click
        DownlinkIOSpeechCalibration()
    End Sub

    Private Sub NetworkLoopSpeechCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NetworkLoopSpeechCalButton.Click
        NetworkLoopIOSpeechCalibration()
    End Sub

    Private Sub MobileLoopSpeechCalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobileLoopSpeechCalButton.Click
        MobileLoopIOSpeechCalibration()
    End Sub

    Private Sub AnFiltCheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnFiltCheckBox1.CheckedChanged
        AnFiltCheckBox2.Checked = AnFiltCheckBox1.Checked
        If AnFiltCheckBox1.Checked And (AnFiltTextBox1.Text = String.Empty) Then AnFiltBrowse()
    End Sub

    Private Sub AnFiltTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnFiltTextBox1.TextChanged   'Synchronize analyzer filter
        AnFiltTextBox2.Text = AnFiltTextBox1.Text
    End Sub

    Private Sub AnFiltTextBox2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnFiltTextBox2.TextChanged   'Synchronize analyzer filter
        AnFiltTextBox1.Text = AnFiltTextBox2.Text
    End Sub

    Private Sub AnFiltCheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnFiltCheckBox2.CheckedChanged
        AnFiltCheckBox1.Checked = AnFiltCheckBox2.Checked
        If AnFiltCheckBox1.Checked And (AnFiltTextBox1.Text = String.Empty) Then AnFiltBrowse()
    End Sub

    Private Sub GenFiltTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltTextBox.TextChanged   'Synchronize generator filter
        GenFiltTextBox1.Text = GenFiltTextBox.Text
    End Sub

    Private Sub GenFiltTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GenFiltTextBox1.TextChanged   'Synchronize generator filter
        GenFiltTextBox.Text = GenFiltTextBox1.Text
    End Sub

    Private Sub FSCheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FSCheckBox1.CheckedChanged   'Synchronize Scale Peak to Full Scale
        If FSCheckBox2.Checked <> FSCheckBox1.Checked Then FSCheckBox2.Checked = FSCheckBox1.Checked
        If FSCheckBox3.Checked <> FSCheckBox1.Checked Then FSCheckBox3.Checked = FSCheckBox1.Checked
        If FSCheckBox4.Checked <> FSCheckBox1.Checked Then FSCheckBox4.Checked = FSCheckBox1.Checked
    End Sub

    Private Sub FSCheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FSCheckBox2.CheckedChanged   'Synchronize Scale Peak to Full Scale
        If FSCheckBox1.Checked <> FSCheckBox2.Checked Then FSCheckBox1.Checked = FSCheckBox2.Checked
        If FSCheckBox3.Checked <> FSCheckBox2.Checked Then FSCheckBox3.Checked = FSCheckBox2.Checked
        If FSCheckBox4.Checked <> FSCheckBox2.Checked Then FSCheckBox4.Checked = FSCheckBox2.Checked
    End Sub

    Private Sub FSCheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FSCheckBox3.CheckedChanged   'Synchronize Scale Peak to Full Scale
        If FSCheckBox1.Checked <> FSCheckBox3.Checked Then FSCheckBox1.Checked = FSCheckBox3.Checked
        If FSCheckBox2.Checked <> FSCheckBox3.Checked Then FSCheckBox2.Checked = FSCheckBox3.Checked
        If FSCheckBox4.Checked <> FSCheckBox3.Checked Then FSCheckBox4.Checked = FSCheckBox3.Checked
    End Sub

    Private Sub FSCheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FSCheckBox4.CheckedChanged   'Synchronize Scale Peak to Full Scale
        If FSCheckBox1.Checked <> FSCheckBox4.Checked Then FSCheckBox1.Checked = FSCheckBox4.Checked
        If FSCheckBox2.Checked <> FSCheckBox4.Checked Then FSCheckBox2.Checked = FSCheckBox4.Checked
        If FSCheckBox3.Checked <> FSCheckBox4.Checked Then FSCheckBox3.Checked = FSCheckBox4.Checked
    End Sub

#End Region

End Class
